#!/usr/local/bin/perl
open(MSGFILE, $ARGV[0]) or die ("Cannot find note.");

$note = "";
$line = <MSGFILE>;
while ($line = <MSGFILE>) { $note = $note . $line; }
close(MSGFILE);

@key = ( "DEAR APPRENTICE|FELLOW SEEKER",
         "YOU",
         "PROBABLY|SHOULD",
         "KNOW ABOUT THE",
         "HIDDEN|SECRET",
         "DOORWAY|PANEL",
         "IN THE",
         "NEXT CHAMBER|READING ROOM",
         "BY NOW",
         "AFTER LONG RESEARCH I THINK I FOUND OUT|LONG HOURS OF READING SHOWED ME|MY INVESTIGATION ON IT REVEALED",
         "THE",
         "COMMAND|MAGIC",
         "PHRASE|WORD",
         "NECESSARY|NEEDED",
         "TO BE",
         "password",
         "JUST",
         "FOR WHAT REASON|WHY",
         "THE",
         "CHAMBER|ROOM",
         "BEHIND|BEYOND",
         "THE",
         "DOORWAY|PANEL",
         "IS SO",
         "EXCEPTIONALLY|EXTRAORDINARILY",
         "PROTECTED I CAN ONLY",
         "GUESS|SPECULATE ABOUT",
         "I BELIEVE|IT IS MY BELIEF HOWEVER",
         "THAT IT WAS",
         "MEANT|SUPPOSED",
         "TO",
         "HOLD|HOUSE",
         "A QUITE POWERFUL|AN ANTIQUE",
         "ARTIFACT|OBJECT",
         "I",
         "SHALL|WILL",
         "ENTER IT|FIND OUT|INVESTIGATE FURTHER",
         "LATER|TODAY|TOMORROW",
         "JUST IN CASE|TO EASE MY FEARS",
         "I",
         "SHALL|WILL",
         "HIDE|LEAVE",
         "THIS",
         "NOTE|SCROLL",
         "IN THE LIBRARY",
         "FOR NOW|UNTIL I RETURN",
         "GRAZAN|HITEZE|ZENOFU",
         "THE",
         "LIBRARIAN|MAGE|PRIEST|SAGE|SCHOLAR|SEEKER" );

sub Decode {
  my($str) = @_;
  foreach $c (keys(%map)) {
    $val = $map{$c};
    $str =~ s/${c}/${val}/g;
  }
  return $str;
}

sub Decide {
  if ($num == 0) { return 0; }

  $tgtlen = length($list[$x]);
  $possible = "";
  for ( $j = 0; $j <= $num; $j++ ) {
    @words = split(" ",$options[$j]);
    $len[$j] = length($words[0]);
    if ( $len[$j] == $tgtlen ) { $possible = $possible . "$j"; }
  }

  if ( length($possible) == 0 ) { die("No possible matches."); }
  if ( length($possible) == 1 ) { return $possible; }

  $tgtwrd = Decode $list[$x];
  foreach $choiceleft (split("",$possible)) {
    @words = split(" ",$options[$choiceleft]);
    $word = $words[0];
    @codechar = split("", $tgtwrd);
    @keychar = split("", $word);
    for ( $ind = 0; $ind <= $#keychar; $ind++ ) {
      if ( $codechar[$ind] =~ m/[A-Z]/ ) {
        if ( $keychar[$ind] ne $codechar[$ind] ) {
          $possible =~ s/$choiceleft//;
          break;
        }
      }
    }
  }

  if ( length($possible) == 0 ) { die("No possible matches."); }
  if ( length($possible) == 1 ) { return $possible; }

  print "Can't decide yet:  $possible\n";

  return -1;
}

sub AddCode {
  my($choice) = @_;
  @words = split(" ",$options[$choice]);
  foreach $word (@words) {
    $noteword = $list[$x];
    @codechar = split("", $noteword);
    @keychar = split("", $word);
    for ( $ind = 0; $ind <= $#keychar; $ind++) {
      if ( !exists $map{"$codechar[$ind]"} ) {
        $map{"$codechar[$ind]"} = $keychar[$ind];
        #print "Added $codechar[$ind] -> $keychar[$ind]\n";
      }
    }
    #print "Word: $word $noteword\n";
    $x++;
  }
}

$note = lc($note);
$note_b = $note;
$note_b =~ tr/,".//d;
@list = split(" ",$note_b);
undef $note_b;

$i = 0; $x = 0;
while ( $i <= $#key ) {
  @options = split(/\|/,$key[$i]);
  $num = $#options;

  if ( $num == 0 && $key[$i] eq "password" ) { $i++; $x++; next; }
  $choice = Decide;
  if ( $choice == -1 ) { die("Bad choice"); }
  AddCode $choice;

  $i++;
}
$note = Decode $note;
print "$note";
