/set TD_attack=kill
/set TD_delay=1
/set TD_sp=50
/set TD_enable=0
/set TD_hits=0
/set TD_total=0
/set TD_max=0
/set TD_min=0

/echo -aB ## Bandu Training Dummy Stats loaded.
/echo -aB ## Type "/dummy" for more info

/def -i -Fp10 -mregexp -t'^[> ]*Sanlei the Weapon Master \(south\)$' TDenable = \
  /set TD_inroom=1

/def -i -Fp10 -mregexp -t'^[> ]*Near a hut in a clearing \(north and west\)$' TDdisable = \
  /set TD_inroom=0

/def -i Dummy = \
  /echo -aB * Bandu Training Dummy %;\
  /echo -aB * %;\
  /echo -aB * /dummyset <attack> <delay> <spcost> %;\
  /echo -aB * /dummystart <iterations> %;\
  /echo -aB * /dummystop %;\
  /echo -aB * /dummyreport %;\

/def -i DummySet = \
  /if (TD_enable) \
    /DummyStop %;\
  /endif %;\
  /set TD_attack=kill %;\
  /set TD_delay=1 %;\
  /set TD_sp=0 %;\
  /if ({#}>=1) /set TD_attack=%{1} %;/endif %;\
  /if ({#}>=2) /set TD_delay=%{2} %;/endif %;\
  /if ({#}>=3) /set TD_sp=%{3} %;/endif %;\
  /echo -aB * Bandu Training Dummy Settings %;\
  /echo -aB * %;\
  /echo -aB * Attack$(/uFr %TD_attack 18) %;\
  /echo -aB * Delay (rounds)$(/uFr %TD_delay 10) %;\
  /echo -aB * SP Cost$(/uFr %TD_sp 17)

/def -i DummyStart = \
  /if (TD_inroom) \
    /if ({#}) \
      /set TD_iter=%{1} %;\
    /else \
      /set TD_iter=-1 %;\
    /endif %;\
    /set TD_enable=1 %;\
    /set TD_hits=0 %;\
    /set TD_total=0 %;\
    /set TD_max=0 %;\
    /set TD_min=99999 %;\
    /set TD_mutex=0 %;\
    /eval %TD_attack dummy %;\
  /endif

/def -i DummyStop = \
  /set TD_enable=0 %;\
  /repeat -1 1 /DummyReport

/def -i DummyReport = \
  /if (TD_hits) \
    /let avgatt=$[TD_total/TD_hits] %;\
  /else \
    /let avgatt=0 %;\
  /endif %;\
  /echo -aB * Bandu Training Dummy Report %;\
  /echo -aB * %;\
  /echo -aB * Action: %{TD_attack} %;\
  /echo -aB * %;\
  /echo -aB * Hits$(/uFr %TD_hits 22) %;\
  /echo -aB * Min Damage$(/uFr %TD_min 16)  Avg Damage/attack$(/uFr %avgatt 9) %;\
  /echo -aB * Max Damage$(/uFr %TD_max 16)  Total Damage$(/uFr %TD_total 14)

/def -i -Fp10 -mregexp -t'^[> ]*Sanlei ' TDsansays = \
  /if (TD_enable) \
    /set TD_hits=$[TD_hits+1] %;\
    /if (TD_hits < TD_iter | TD_iter == -1) \
      /if (SP >= TD_sp) \
        /TDretry %;\
      /endif %;\
    /else \
      /DummyStop %;\
    /endif %;\
  /endif

/def -i -Fp10 -mregexp -t'^[> ]*You\'re already engaged this round\.$' TDretry = \
  /if (TD_enable & TD_mutex==0) \
    /let delay=$[TD_delay*2] %;\
    /set TD_mutex=$[TD_mutex+1] %;\
    /repeat -%delay 1 /set TD_mutex=$[TD_mutex-1] %%;%TD_attack dummy %;\
  /endif

/def -i -Fp10 -mregexp -t'^[> ]*.* \(([0-9]+) damage\)$' TDdamage = \
  /if (TD_enable) \
    /set TD_total=$[TD_total+{P1}] %;\
    /if ({P1} < TD_min) /set TD_min=%{P1} %;/endif %;\
    /if ({P1} > TD_max) /set TD_max=%{P1} %;/endif %;\
  /endif

/def -i TDretryspell = \
  /if (TD_enable & SP >= TD_sp) \
    %TD_attack dummy %;\
  /endif
/pHook TDretryspell
