/set AH_Haven=cath
/set AH_Food=side
/set AH_Stomach=0
/set AH_UsePriest=0
/set AH_HealCount=0
/set AH_HealRequest=party heal
/set AH_HealSomewhat=0
/set AH_Recovering=0

/def AH_FightAction =
/def AH_FleeAction =

/set AutoHeal 0
/def -i Heal = \
	/if (AutoHeal) \
		/set AutoHeal 0 %;\
		/echo -aB * AutoHeal off. %;\
	/else \
		/set AutoHeal 1 %;\
		/echo -aB * AutoHeal on. %;\
	/endif

/set AH_UsePriest=0
/def -i UsePriest = \
	/if (AH_UsePriest) \
		/set AH_UsePriest 0 %;\
		/echo -aB * AutoHeal using food only. %;\
	/else \
		/set AH_UsePriest 1 %;\
		/echo -aB * AutoHeal using food and priest. %;\
	/endif

/def -i SetRequest = /set AH_HealRequest %{*}
/def -i SetHaven = /set AH_Haven %{*}
/def -i SetFood = /set AH_Food %{*}
/def -i SetHealSomewhat = /set AH_HealSomewhat %{*}

/def -i AH_HPHook = \
	/if (!AutoHeal) \
		/pUnHook AH_HPHook %;\
		/return %;\
	/endif %;\
	/if (HP == MaxHP & !AH_Stomach) \
		/set AH_Recovering=0 %;\
		/pUnHook AH_HPHook %;\
		/g %{AH_runLoc} %;\
		/AH_FightAction %;\
		/if (Punch) punch %;/endif %;\
	/else \
		/if (AH_Stomach) /return %;/endif %;\
		/if (AH_UsePriest) \
			/if ((AH_HealCount := AH_HealCount + 1) > 3) \
			/echo -aB * Priest won't heal!!! Was killing at %{AH_runLoc} %;\
			/set AH_Stomach=1 %;\
			devour %{AH_Food} %;\
		/else \
			%{AH_HealRequest} %;\
			/endif %;\
		/else \
			/set AH_Stomach=1 %;\
			devour %{AH_Food} %;\
		/endif %;\
	/endif

/def -iFp5 -mregexp -t'^[> ]*>>> You are now badly hurt. <<<$' AH_Hurt = \
	/if (AutoHeal & !AH_Recovering) \
		/AH_FleeAction %;\
		/set AH_runLoc=%{mpCurLoc} %;/g %{AH_Haven} %;bind %;\
		/set AH_HealCount=0 %;\
		/set AH_Recovering=1 %;\
		/pHook AH_HPHook %;\
	/endif
/def -iFp5 -mregexp -t'^[> ]*>>> You are now in very bad shape. <<<$' AH_ReallyHurt = /if (AutoHeal) /AH_Hurt %;/endif
/def -iFp5 -mregexp -t'^[> ]*>>> You are now somewhat hurt. <<<$' AH_KindaHurt = /if (AutoHeal & AH_HealSomewhat) /AH_Hurt %;/endif

/def -iFp5 -mregexp -t'^[> ]*Your stomach feels much less leaden.$' AH_Rested =\
	/set AH_Stomach=0 %;\
	/if (AutoHeal) /AH_HPHook %;/endif

/def -iFp5 -mregexp -t'^[> ]*You eat the last bite of' AH_NoMoFood = \
	/if (AutoHeal) \
		/echo -aB * Out of Food!!! Was killing at %{AH_runLoc} %;\
		/set AH_Recovering=0 %;\
	/endif %;\
	bury %{AH_Food}

/def -i UnloadHeal = \
	/unset AutoHeal %;\
	/unset AH_UsePriest %;\
	/unset AH_runLoc %;\
	/unset AH_Haven %;\
	/unset AH_Food %;\
	/unset AH_Stomach %;\
	/unset AH_Recovering %;\
	/undef AH_FightAction %;\
	/undef AH_FleeAction %;\
	/unset AH_HealCount %;\
	/unset AH_HealRequest %;\
	/unset AH_HealSomewhat %;\
	/undef Heal %;\
	/undef UsePriest %;\
	/undef SetRequest %;\
	/undef SetHaven %;\
	/undef SetFood %;\
	/undef SetHealSomewhat %;\
	/undef AH_KindaHurt %;\
	/undef AH_Hurt %;\
	/undef AH_ReallyHurt %;\
	/undef AH_Rested %;\
	/undef AH_NoMoFood %;\
	/pUnHook AH_HPHook %;\
	/undef AH_HPHook %;\
	/undef UnloadHeal
