/set NameFile=fnames
/set ListFile=flist
 
/def -i DoFighterNames = /uaputq startranks%;/uaputq stopranks%;/eval ,\10rankings 1000\10,
 
                                                               
/def -i StartRanks = \
	/set FighterNames=%;\
	/ugagon%;\
	/def -i -mregexp -t'[ ]*[0-9]+\.[ ]+[-0-9]+ ([A-Za-z]+)' CatchRankings \
		= /AddName %%P1

/def -i StopRanks  = \
	/ugagoff%;\
	/purge -i CatchRankings%;\
	/WriteNames%;\
	/ProcessNames
 
/def -i ProcessNames = \
	/sh sort %{NameFile} -o %{NameFile}
 
/def -i AddName = \
	/set FighterNames=%{FighterNames}\10%{*}%;\
	/set TotalNum=$[TotalNum+1]

/def -i WriteNames = \
	/quote -0 /echo !echo '%{FighterNames}' > %{NameFile}
 
;P NNNNNNNNNNN LLL lll KKKKK DDD ddd N ArchName.........               Class   
;* StormDancer 103  +2 27354   7  +1 ! the Tree's daemon caretaker      490642
 
 
/def -i -F -mregexp -t'([A-Za-z]+) .+ \(([0-9]+) / Fighter\) \((male|female|neuter)\)(.*)' NameAndLevel = \
;	/echo % Name: %P1, Level: %P2, PK: %P4%;\
	/set CurName=%P1%;\
	/set CurLevel=%P2%;\
	/if /test CurLevel < 15%;/then \
		/set CurLevel=%;\
	/endif%;\
	/set CurPK=%P4

/def -i -F -mregexp -t'Kills/Deaths: ([0-9]+) / ([0-9]+)' KillsAndDeaths = \
;	/echo % Kills: %P1, Deaths: %P2%;\
	/set CurKills=%P1%;\
	/set CurDeaths=%P2
 
/def -i -F -mregexp -t'Archfoe: (.+) class ([0-9]+)' ArchAndClass = \
;	/echo % Archfoe: %P1, Class: %P2%;\
	/set CurArch=%P1%;\
	/set CurClass=%P2%;\


/def -i PrintHeader = \
;		/test Header := "PK Fighter     Lvl dL  Kills Dth dD  New  Arch                    Arch Class"%;\
;		/echo -- %{Header}%;\
;		/WriteLine %{Header}%;\
;		/echo -- $[strrep("-", 78)]%;\
;		/WriteLine $[strrep("-", 78)]%;\

/def -i DoOneFighter = /uaputq startplayer%;/uaputq stopplayer%;/eval ,\10page -d %{1}\10,%;/set NumDone=$[NumDone+1]

/def DoAllFighters = /PrintHeader%;/quote -1 /doonefighter '"fnames"%;/set NumDone=0%;/repeat -30 20 /ShowProgress

/def ShowProgress = /echo -aB %% DoFighterList: %{NumDone}/%{TotalNum}, $[NumDone*100/TotalNum]%%

/def StartPlayer = /set DoingStats=1%;/if /test DoGag==1%;/then /ugagon%;/endif%;/set CurPK=%;/set CurLevel=%;/set CurName=%;/set CurArch=%;/set CurDeaths=%;/set CurKills=%;/set CurClass=

/def StopPlayer  = /set DoingStats=0%;/ugagoff%;/ConvertData

/def ConvertData = \
	/if /test CurLevel !~ ""%;/then  \
		/LoadOldData %{CurName}%;\
		/if /test CurPK !~ ""%;/then \
			/test CurOutput := "PK "%;\
		/else \
			/test CurOutput := "-  "%;\
		/endif%;\
		/AddOutput l 11 %{CurName}%;\
		/AddOutput r 3  %{CurLevel}%;\
		/AddOutput r 3  $(/LevelChange)%;\
		/AddOutput r 5  %{CurKills}%;\
		/AddOutput r 3  %{CurDeaths}%;\
		/AddOutput r 3  $(/DeathChange)%;\
		/if /test NewArch == 1%;/then \
			/test CurOutput := strcat(CurOutput, "!!  ")%;\
		/else \
			/test CurOutput := strcat(CurOutput, "    ")%;\
		/endif%;\
		/AddOutput l 27 %{CurArch}%;\
		/AddOutput r 7  %{CurClass}%;\
		/WriteLine %{CurOutput}%;\
	/endif

/def -i WriteLine = \
	/quote -0 /echo !echo "%{*}" >> %{ListFile}

/def -i LevelChange
/def -i LoadOldData = /quote -0 /set OldLine !"egrep '^\(\-  |PK \)%{*} ' flist.old"%;
/def -i DeathChange

/def -i AddOutput = \
	/let just=%{1}%;\
	/let wlen=%{2}%;\
	/shift 2%;\
	/test stuff := {*}%;\
	/test rlen := strlen(stuff)%;\
	/if /test rlen > wlen%;/then \
		/test stuff := substr(stuff,0,wlen)%;\
	/endif%;\
	/if /test just =~ "l"%;/then \
		/test CurOutput := strcat(CurOutput,stuff, strrep(" ", (wlen-rlen) > 0 ? (wlen-rlen) : 0))%;\
	/else \
		/test CurOutput := strcat(CurOutput,strrep(" ", (wlen-rlen) > 0 ? (wlen-rlen) : 0),stuff)%;\
	/endif%;\
	/AddSpace

		

/def -i AddSpace = /test CurOutput := strcat(CurOutput, " ")
