;; Blackjack
; split

/set gameInProg 0
/set bj_minBet 50
/set bj_maxBet 1000

/set bj_findPlayers 1
/set bj_waitPlayers 0
/set bj_numPlayers 0
/set bj_curMove 0

/gDef bj_reset = \
  /set emulation=ansi_attr %;\
  /set bj_waitPlayers 0 %;\
  /set bj_numPlayers 0 %;\
  /set bj_curMove 0 %;\
  /set bj_ins 0 %;\
  /set bj_doub 0 %;\
  /repeat -2 1 /set gameInProg 0 %;\
  /repeat -2 1 /set bj_findPlayers 1

/gDef -mregexp -t'^[> ]*\[0;32m([A-Za-z]*) gives you ([0-9]*) coins.\[0m$' bj_fakeBet = \
  /if (bj_waitPlayers) \
    stick %P1 %;\
  /endif

/gDef -mregexp -t'^[> ]*([A-Za-z]*) gives you ([0-9]*) coins.$' bj_bet = \
  /set bj_tempPlayer %P1 %;\
  /set bj_tempBet %P2 %;\
  /if (bj_waitPlayers & (!bj_ins)) \
    /if (bj_numPlayers >= 10) \
      say Sorry, table's full. %;\
      give %bj_tempBet coins to %bj_tempPlayer %;\
      /return %;\
    /elseif (bj_tempBet < bj_minBet) \
      say I'm sorry, that's not enough to play. %;\
      give %bj_tempBet coins to %bj_tempPlayer %;\
      /return %;\
    /elseif (bj_numPlayers > 0) \
      /let x 1 %;\
      /while (x <= bj_numPlayers) \
        /eval /set bj_temp2 %%{bj_p%{x}} %;\
        /if (bj_tempPlayer =~ bj_temp2) \
          say You can't bet twice in a game. %;\
          give %bj_tempBet coins to %bj_tempPlayer %;\
          /return %;\
        /endif %;\
        /let x $[x + 2] %;\
      /done %;\
    /endif %;\
    /if (bj_tempBet > bj_maxBet) \
      say Current maximum bet is %{bj_maxBet}. %;\
      /set bj_temp $[bj_tempBet - bj_maxBet] %;\
      give %bj_temp coins to %bj_tempPlayer %;\
      /set bj_tempBet %{bj_maxBet} %;\
    /endif %;\
    /if (bj_numPlayers > 0) \
      /set bj_numPlayers=$[bj_numPlayers + 2] %;\
    /else \
      /set bj_numPlayers 1 %;\
    /endif %;\
    /set bj_p%{bj_numPlayers} %{bj_tempPlayer} %;\
    /set bj_bet%{bj_numPlayers} %{bj_tempBet} %;\
    /eval say %%{bj_p%{bj_numPlayers}} is betting %%{bj_bet%{bj_numPlayers}}. %;\
    /set bj_winnings $[bj_winnings + bj_tempBet] %;\
  /elseif ((bj_ins > 0) & (bj_ins <= bj_numPlayers)) \
    /eval /set bj_curInsP %%{bj_p%{bj_ins}} %;\
    /if (bj_curInsP =~ bj_tempPlayer) \
      /if (bj_tempBet == bj_temp) \
        /set bj_ins%{bj_ins} %{bj_tempBet} %;\
        say %bj_tempPlayer bought insurance. %;\
        /set bj_winnings $[bj_winnings + bj_tempBet] %;\
        /set bj_ins $[bj_ins + 2] %;\
      /else \
        say That is not the right amount. %;\
        give %bj_tempBet coins to %bj_tempPlayer %;\
      /endif %;\
      /bj_sellIns %;\
    /endif %;\
  /elseif (bj_doub) \
    /eval /set bj_curDoubP %%{bj_p%{bj_curMove}} %;\
    /if (bj_curDoubP =~ bj_tempPlayer) \
      /eval /set bj_temp %%{bj_bet%{bj_curMove}} %;\
      /if (bj_tempBet == bj_temp) \
        /set bj_bet%{bj_curMove} $[bj_temp * 2] %;\
        /set bj_doub%{bj_curMove} 1 %;\
        /set bj_winnings $[bj_winnings + bj_tempBet] %;\
        emote hands %bj_tempPlayer a card face down. %;\
        /bj_advanceP %;\
      /else \
        say That is not the right amount. %;\
        give %bj_tempBet coins to %bj_tempPlayer %;\
      /endif %;\
      /bj_getMove %;\
    /endif %;\
  /elseif (bj_splt) \
    /eval /set bj_curSpltP %%{bj_p%{bj_curMove}} %;\
    /if (bj_curSpltP =~ bj_tempPlayer) \
      /eval /set bj_temp %%{bj_bet%{bj_curMove}} %;\
      /if (bj_tempBet == bj_temp) \
        /eval /set bj_t=$$(/nth 1 %%{bj_card%{bj_curMove}}) %;\
        /set bj_t1 $[bj_curMove + 1] %;\
        /set bj_card%{bj_curMove} %{bj_t} %;\
        /set bj_splt%{bj_curMove} %{bj_t} %;\
        /eval /set bj_p%{bj_t1} %%{bj_p%{bj_curMove}} %;\
        /set bj_card%{bj_t1} %{bj_t} %;\
        /set bj_splt%{bj_t1} %{bj_t} %;\
        /set bj_done%{bj_t1} 0 %;\
        /set bj_bet%{bj_t1} %{bj_tempBet} %;\
        /set bj_winnings $[bj_winnings + bj_tempBet] %;\
        emote deals %bj_tempPlayer two more cards. %;\
        /bj_add bj_card%{bj_curMove} %;\
        /bj_add bj_card%{bj_t1} %;\
        /if (bj_t =~ 'A') \
          /eval say %%{bj_p%{bj_curMove}} split a pair of aces, and now has %%{bj_card%{bj_curMove}} and %%{bj_card%{bj_t1}}. %;\
          /set bj_curMove $[bj_curMove + 2] %;\
        /endif %;\
      /else \
        say That is not the right amount. %;\
        give %bj_tempBet coins to %bj_tempPlayer %;\
      /endif %;\
      /bj_getMove %;\
    /endif %;\
  /endif

/gDef -mregexp -t'^[> ]*([A-Za-z]*) exclaims?: Blackjack!+$' bj_init = \
  /if (Games & !gameInProg & bj_findPlayers) \
    .. %;\
    /set emulation=raw %;\
    /set bj_findPlayers 0 %;\
    /set gameInProg 1 %;\
    /let x 1 %;\
    /while (x <= 10) \
      /set bj_bet%{x} 0 %;\
      /let x=$[x + 1] %;\
    /done %;\
    /repeat -2 1 /bj_init2 %;\
  /endif

/gDef bj_init2 = \
  /if (Gold < 10000) \
    emote is broke.  Sorry, no game. ;P %;\
    /bj_reset %;\
    /return %;\
  /endif %;\
  /set bj_numPlayers 0 %;\
  /set bj_waitPlayers 1 %;\
  say Blackjack!  Taking bets from %{bj_minBet} to %{bj_maxBet} (give coins to place a bet) %;\
  /repeat -9 1 /bj_check %;\
  /repeat -15 1 /bj_check2 %;\
  /repeat -17 1 /bj_start %;\

/gDef bj_check = \
  /if (bj_numPlayers == 0) \
    say Anyone? %;\
  /elseif (bj_numPlayers < 8) \
    say Anyone else? %;\
  /endif

/gDef bj_check2 = \
  /set bj_waitPlayers 0 %;\
  /if (bj_numPlayers) \
    /set bj_numPlayers $[bj_numPlayers + 1] %;\
    /if ($(/deck_num) >= 52) \
      say Okay, no more bets. %;\
    /else \
      say Okay, no more bets.  Shuffling. (using 2 decks) %;\
      /deck_create 2 %;\
    /endif %;\
  /endif

/gDef bj_start = \
  /set bj_ins 0 %;\
  /set bj_doub 0 %;\
  /set bj_waitPlayers 0 %;\
  /let x 1 %;\
  /while (x <= 10) \
    /set bj_ins%{x} 0 %;\
    /set bj_splt%{x} -1 %;\
    /set bj_done%{x} 1 %;\
    /set bj_doub%{x} 0 %;\
    /let x $[x + 1] %;\
  /done %;\
  /if (bj_numPlayers == 0) \
    say Aww, no one wanted to play.  Too bad. %;\
    /bj_reset %;\
    /return %;\
  /endif %;\
  say Dealing. %;\
  /let x 1 %;\
  /while (x <= bj_numPlayers) \
    /unset bj_card%{x} %;\
    /bj_add bj_card%{x} %;\
    /bj_add bj_card%{x} %;\
    /set bj_done%{x} 0 %;\
    /eval say %%{bj_p%{x}} has %%{bj_card%{x}}. %;\
    /let x $[x + 2] %;\
  /done %;\
  /unset bj_card0 %;\
  /bj_add bj_card0 %;\
  emote is showing %{bj_card0}. %;\
  /if (bj_card0 =~ 'A') \
    /set bj_ins 1 %;\
    /bj_sellIns %;\
  /else \
    /set bj_curMove 1 %;\
    /bj_getMove %;\
  /endif

/gDef -mregexp -t'^[> ]*\[0;32m([A-Za-z]*) nods solemnly.\[0m$' bj_nod = \
  /if ((bj_curMove) & (bj_curMove <= bj_numPlayers) & (!bj_splt)) \
    /eval /set bj_tempPlayer %%{bj_p%{bj_curMove}} %;\
    /if (bj_tempPlayer =~ %P1) \
      /eval emote hands %%{bj_p%{bj_curMove}} another card. %;\
      /bj_add bj_card%{bj_curMove} %;\
      /bj_value bj_card%{bj_curMove} %;\
      /if (bj_value > 21) \
        /eval say %%{bj_p%{bj_curMove}} now has %%{bj_card%{bj_curMove}}. %;\
        say Bust! %;\
        /eval say %%{bj_p%{bj_curMove}} lost %%{bj_bet%{bj_curMove}}. %;\
        /set bj_done%{bj_curMove} 1 %;\
        /bj_advanceP %;\
      /endif %;\
    /bj_getMove %;\
    /endif %;\
  /endif

/gDef -mregexp -t'^[> ]*\[0;32m([A-Za-z]*) shakes (his|her|its) head.\[0m$' bj_shake = \
  /if ((bj_curMove) & (bj_curMove <= bj_numPlayers) & (!bj_splt)) \
    /eval /set bj_curPlayer %%{bj_p%{bj_curMove}} %;\
    /if (bj_curPlayer =~ {P1}) \
      say %bj_curPlayer stays. %;\
      /bj_advanceP %;\
      /bj_getMove %;\
    /endif %;\
  /elseif ((bj_ins > 0) & (bj_ins <= bj_numPlayers)) \
    /eval /set bj_curInsP %%{bj_p%{bj_ins}} %;\
    /if (bj_curInsP =~ {P1}) \
      /unset bj_curInsP %;\
      /set bj_ins $[bj_ins + 2] %;\
      /bj_sellIns %;\
    /endif %;\
  /elseif (bj_splt) \
    /set bj_splt%{bj_curMove} 0 %;\
    /bj_getMove %;\
  /endif

/gDef -mregexp -t'^[> ]*\[0;32m([A-Za-z]*) boggles at the very concept.\[0m$' bj_reshow = \
  /if ((!bj_findPlayers) & (bj_curMove > 0) & (bj_curMove <= bj_numPlayers) & (!bj_splt)) \
    /let x 1 %;\
    /while (x <= bj_numPlayers) \
      /eval /set bj_tempIns %%{bj_ins%{x}} %;\
      /eval /set bj_tempDoub %%{bj_doub%{x}} %;\
      /eval /set bj_tempBet %%{bj_bet%{x}} %;\
      /eval /set bj_tempFrst $[mod(%x, 2)] %;\
      /if (bj_tempIns) \
        /eval say %%{bj_p%{x}} paid %bj_tempIns for insurance. %;\
      /endif %;\
      /if ((bj_tempDoub) & (bj_tempFrst) & (bj_tempBet)) \
        /eval say %%{bj_p%{x}} has %%{bj_card{x}} showing, bet %%{bj_bet%{x}}, and doubled down. %;\
      /elseif ((!bj_tempDoub) & (bj_tempFrst) & (bj_tempBet)) \
        /eval say %%{bj_p%{x}} has %%{bj_card%{x}}, and bet %%{bj_bet%{x}}. %;\
      /elseif ((bj_tempDoub) & (!bj_tempFrst) & (bj_tempBet)) \
        /eval say %%{bj_p%{x}}'s second hand has %%{bj_card%{x}} showing, bet %%{bj_bet%{x}}, and doubled down. %;\
      /elseif ((!bj_tempDoub) & (!bj_tempFrst) & (bj_tempBet)) \
        /eval say %%{bj_p%{x}}'s second hand has %%{bj_card%{x}}, and bet %%{bj_bet%{x}}. %;\
      /endif %;\
      /let x $[x + 1] %;\
    /done %;\
    /eval emote is showing %{bj_card0}. %;\
    /if (bj_len == 2) \
      /eval say %%{bj_p%{bj_curMove}}'s turn.  Another card? (nod, shake, boggle, or pay %%{bj_bet%{bj_curMove}} to double) %;\
    /else \
      /eval say %%{bj_p%{bj_curMove}}'s turn.  Another card? (nod, shake, or boggle) %;\
    /endif %;\
  /endif

/gDef bj_sellIns = \
  /if (bj_ins <= bj_numPlayers) \
    /eval /set bj_temp $$[bj_bet%{bj_ins} / 2.0] %;\
    /eval /set bj_temp $[trunc(%{bj_temp})] %;\
    /eval say %%{bj_p%{bj_ins}}, would you like to buy insurance? (pay %bj_temp or shake) %;\
  /else \
    /set bj_curMove 1 %;\
    /bj_getMove %;\
  /endif

/gDef bj_getMove = \
  /set bj_splt 0 %;\
  /set bj_doub 0 %;\
  /if (bj_curMove <= bj_numPlayers) \
    /eval say %%{bj_p%{bj_curMove}}, your turn. %;\
    /eval say You have %%{bj_card%{bj_curMove}}. %;\
    /bj_value bj_card%{bj_curMove} %;\
    /eval /set bj_tempSplt %%{bj_splt%{bj_curMove}} %;\
    /eval /set bj_tempSplt2 $[mod(%bj_curMove, 2)] %;\
    /if ((bj_tempSplt == -1) & (bj_tempSplt2)) \
      /eval /set bj_temp=$$(/nth 1 %%{bj_card%{bj_curMove}}) %;\
      /eval /set bj_temp2=$$(/nth 2 %%{bj_card%{bj_curMove}}) %;\
      /if (bj_temp =~ bj_temp2) \
        /set bj_splt 1 %;\
        /eval say Would you like to split? (pay %%{bj_bet%{bj_curMove}} or shake) %;\
        /return %;\
      /else \
        /set bj_splt%{bj_curMove} 0 %;\
      /endif %;\
    /endif %;\
    /if (bj_value == -1) \
      say Blackjack! %;\
      /bj_advanceP %;\
      /bj_getMove %;\
    /elseif (bj_len == 2) \
      /set bj_doub 1 %;\
      /eval say Another card? (nod, shake, boggle, or pay %%{bj_bet%{bj_curMove}} to double) %;\
    /else \
      /set bj_doub 0 %;\
      say Another card? (nod, shake, or boggle) %;\
    /endif %;\
    /unset bj_tempSplt %;\
    /unset bj_tempSplt2 %;\
  /else \
    /set bj_curMove 0 %;\
    /let x 1 %;\
    /while (x <= bj_numPlayers) \
      /eval /set bj_temp %%{bj_doub%{x}} %;\
      /eval /set bj_tempBet %%{bj_bet%{x}} %;\
      /if ((bj_temp) & (bj_tempBet)) \
        /bj_add bj_card%{x} %;\
        /bj_value bj_card%{x} %;\
        /eval say %%{bj_p%{x}} turns over the card. %;\
        /eval say %%{bj_p%{x}} has %%{bj_card%{x}}. %;\
        /if (bj_value > 21) \
          say Bust! %;\
          /eval say %%{bj_p%{x}} lost %%{bj_bet%{x}}. %;\
          /set bj_done%{x} 1 %;\
        /endif %;\
      /endif %;\
      /let x $[x + 1] %;\
    /done %;\
    /bj_dealMove %;\
  /endif

/gDef bj_advanceP = \
  /set bj_curMove $[bj_curMove + 1] %;\
  /eval /set bj_temp %%{bj_bet%{bj_curMove}} %;\
  /if (!bj_temp) \
    /set bj_curMove $[bj_curMove + 1] %;\
  /endif

/gDef bj_dealMove = \
  /set bj_allDone 1 %;\
  /let x 1 %;\
  /while (x <= bj_numPlayers) \
    /eval /set bj_temp %%{bj_done%{x}} %;\
    /if (!bj_temp) \
      /set bj_allDone 0 %;\
      /break %;\
    /endif %;\
    /let x $[x + 1] %;\
  /done %;\
  /if (bj_allDone) \
    /bj_reset %;\
    /return %;\
  /endif %;\
  emote turns over his card. %;\
  /bj_add bj_card0 %;\
  emote has %{bj_card0}. %;\
  /bj_value bj_card0 %;\
  /if (bj_value == -1) \
    emote has a blackjack! %;\
    /repeat -2 1 /bj_payout -1 %;\
    /return %;\
  /endif %;\
  /if (bj_value < 17) \
    /repeat -2 1 /bj_dealMove2 %;\
  /else \
    emote stays. %;\
   /repeat -2 1 /bj_payout %{bj_value} %;\
  /endif

/gDef bj_dealMove2 = \
  /if (bj_value < 17) \
    emote takes another card. %;\
    /bj_add bj_card0 %;\
    emote has %{bj_card0}. %;\
    /bj_value bj_card0 %;\
  /endif %;\
  /if (bj_value > 21) \
    emote busts! %;\
    /repeat -2 1 /bj_payout %{bj_value} %;\
  /elseif (bj_value >= 17) \
    emote stays. %;\
    /repeat -2 1 /bj_payout %{bj_value} %;\
  /else \
    /repeat -2 1 /bj_dealMove2 %;\
  /endif %;\

/gDef bj_payout = \
  /set bj_dealer %1 %;\
  /let x 1 %;\
  /while (x <= bj_numPlayers) \
    /eval /set bj_spltAce %%{bj_splt%{x}} %;\
    /eval /set bj_temp %%{bj_done%{x}} %;\
    /if (!bj_temp) \
      /eval /set bj_tempSplt $[mod(%x, 2)] %;\
      /if (!bj_tempSplt) \
        /eval say For %%{bj_p%{x}}'s second hand, %;\
      /endif %;\
      /bj_value bj_card%{x} %;\
      /if ((bj_value == -1) & (bj_spltAce =~ 'A')) \
        /set bj_value 21 %;\
      /endif %;\
      /if ((bj_value <= 21 ) & (bj_value == bj_dealer)) \
        /eval /set bj_win $$[bj_bet%{x} * 1] %;\
        /eval say %%{bj_p%{x}} pushes and gets %{bj_win} back. %;\
        /eval give %{bj_win} coins to %%{bj_p%{x}} %;\
        /set bj_winnings $[bj_winnings - bj_win] %;\
      /elseif (bj_dealer == -1) \
        /set bj_win 0 %;\
        /eval say %%{bj_p%{x}} lost %%{bj_bet%{x}}. %;\
      /elseif (bj_value == -1) \
        /eval /set bj_win $$[bj_bet%{x} * 2.5] %;\
        /eval /set bj_win $[trunc(%bj_win)] %;\
        /eval say %%{bj_p%{x}} had a blackjack and wins %{bj_win}. %;\
        /eval give %{bj_win} coins to %%{bj_p%{x}} %;\
        /set bj_winnings $[bj_winnings - bj_win] %;\
      /elseif ((bj_dealer > 21) & (bj_value <= 21)) \
        /eval /set bj_win $$[bj_bet%{x} * 2] %;\
        /eval say %%{bj_p%{x}} wins %{bj_win}. %;\
        /eval give %{bj_win} coins to %%{bj_p%{x}} %;\
        /set bj_winnings $[bj_winnings - bj_win] %;\
      /elseif ((bj_value > bj_dealer) & (bj_value <= 21)) \
        /eval /set bj_win $$[bj_bet%{x} * 2] %;\
        /eval say %%{bj_p%{x}} wins %{bj_win}. %;\
        /eval give %{bj_win} coins to %%{bj_p%{x}} %;\
        /set bj_winnings $[bj_winnings - bj_win] %;\
      /else \
        /set bj_win 0 %;\
        /eval say %%{bj_p%{x}} lost %%{bj_bet%{x}}. %;\
      /endif %;\
    /endif %;\
    /let x $[x + 1] %;\
  /done %;\
  /let x 1 %;\
  /while (x <= bj_numPlayers) \
    /eval /set bj_tempIns %%{bj_ins%{x}} %;\
    /if (bj_tempIns) \
      /if (bj_dealer == -1) \
        /eval /set bj_win $[bj_tempIns * 3] %;\
        /eval say %%{bj_p%{x}} wins %bj_win by insurance. %;\
        /eval give %{bj_win} coins to %%{bj_p%{x}} %;\
        /set bj_winnings $[bj_winnings - bj_win] %;\
      /else \
        /eval say %%{bj_p%{x}} lost %bj_tempIns by insurance. %;\
      /endif %;\
    /endif %;\
    /let x $[x + 2] %;\
  /done %;\
  /bj_reset

/gDef bj_value = \
  /set bj_aces 0 %;\
  /set bj_value 0 %;\
  /eval /set bj_len $$(/length %%{%{1}}) %;\
  /let x 1 %;\
  /while (x <= bj_len) \
    /eval /set bj_temp=$$(/nth %{x} %%{%{1}}) %;\
    /if (bj_temp =~ 'A') \
      /set bj_aces $[bj_aces + 1] %;\
      /set bj_value $[bj_value + 11] %;\
    /elseif ((bj_temp =~ 'J') | (bj_temp =~ 'Q') | (bj_temp =~ 'K')) \
      /set bj_value $[bj_value + 10] %;\
    /else \
      /set bj_value $[bj_value + bj_temp] %;\
    /endif %;\
    /let x $[x + 1] %;\
  /done %;\
  /while ((bj_value > 21) & (bj_aces)) \
    /set bj_value $[bj_value - 10] %;\
    /set bj_aces $[bj_aces - 1] %;\
  /done %;\
  /if ((bj_value == 21) & (bj_len == 2)) \
    /set bj_value -1 %;\
  /endif

/gDef bj_add = \
  /set bj_curCard $(/deck_dealNS) %;\
  /eval /set %1 %%{%1} %bj_curCard
