/set gameInProg 0 
/set c4_findPlayers 1 
/set c4_numPlayers 0
/set c4_game 0
/set c4_moves 0
/set c4_win 0

/gDef -mregexp -t'^[> ]*[A-Za-z]* exclaims?:.* Connect 4!+$' c4_init = \
  /if (Games & !gameInProg & c4_findPlayers) \
    /set c4_findPlayers 0 %;\
    /set gameInProg 1 %;\
    /set c4_numPlayers 0 %;\
    say Woo!!  Connect 4!  Who wants to play? (say me! to join in) %;\
    say During game, say place [1-7] to make a move. %;\
  /endif

/gDef -mregexp -t'^[> ]*([A-Za-z]+) exclaims?:.* [Mm][Ee]+!+$' c4_findPlayers = \
  /if (!c4_findPlayers) \
    /if (c4_numPlayers == 0) \
      /set c4_p1 %P1 %;\
      /if (c4_p1 =~ 'You') \
        say I will play Red. %;\
      /else \
        say %{c4_p1} will play Red. %;\
      /endif %;\
      /set c4_numPlayers 1 %;\
    /elseif (c4_numPlayers == 1) \
      /set c4_p2 %P1 %;\
      /if (c4_p2 =~ 'You') \
        say I will play Black. %;\
      /else \
        say %{c4_p2} will play Black. %;\
      /endif %;\
      /set c4_numPlayers 2 %;\
      say Let's start! %;\
      /set c4_game 1 %;\
      /c4_startGame %;\
    /endif %;\
  /endif

/gDef -mregexp -t'^[> ]*([A-Za-z]+) says?: .*restart$' c4_restart = \
  /if ((c4_game == 0) | (%P1 =~ c4_p1) | (%P1 =~ c4_p2)) \
    /c4_reset %;\
    say Connect 4 reset. %;\
  /endif

/gDef -mregexp -t'^[> ]*([A-Za-z]+) says?:  ?place ([1-7])$' c4_placePiece = \
  /if ((c4_game == 1) & (c4_p1 =~ %P1)) \
    /c4_place R %{P2} %;\
  /elseif ((c4_game == 2) & (c4_p2 =~ %P1)) \
    /c4_place B %{P2} %;\
  /endif

/gDef -mregexp -t'^[> ]*([A-Za-z]+) says?:.*show .*board$' c4_showBoard = \
  /if ((c4_game > 0) & ((c4_p1 =~ %P1) | (c4_p2 =~ %P1)) | (c4_win >= 4)) \
    /c4_dispBoard %;\
    /c4_announceTurn %;\
  /endif

/gDef c4_startGame = \
  /unset c4_col1 %;\
  /unset c4_col2 %;\
  /unset c4_col3 %;\
  /unset c4_col4 %;\
  /unset c4_col5 %;\
  /unset c4_col6 %;\
  /unset c4_col7 %;\
  /c4_dispBoard %;\
  /c4_announceTurn

/gDef c4_checkWin = \
  /if (c4_game == 1) \
    /set c4_p R %;\
  /else \
    /set c4_p B %;\
  /endif %;\
  /set c4_win 1 %;\
  /set c4_x %{1} %;\
  /eval /set c4_y=$$(/length %%{c4_col%{1}}) %;\
  /let y $[%{c4_y} - 1] %;\
  /while (y > 0) \
    /eval /set c4_temp=$$(/nth %{y} %%{c4_col%{c4_x}}) %;\
    /if (c4_temp =~ c4_p) \
      /set c4_win=$[c4_win + 1] %;\
      /let y=$[y - 1] %;\
    /else \
      /break %;\
    /endif %;\
  /done %;\
  /if (c4_win >= 4) \
    /return %;\
  /endif %;\
  /set c4_win 1 %;\
  /let x $[%{c4_x} - 1] %;\
  /while (x > 0) \
    /eval /set c4_temp=$$(/nth %{c4_y} %%{c4_col%{x}}) %;\
    /if (c4_temp =~ c4_p) \
      /set c4_win=$[c4_win + 1] %;\
      /let x=$[x - 1] %;\
    /else \
      /break %;\
    /endif %;\
  /done %;\
  /let x $[%{c4_x} + 1] %;\
  /while (x <= 7) \
    /eval /set c4_temp=$$(/nth %{c4_y} %%{c4_col%{x}}) %;\
    /if (c4_temp =~ c4_p) \
      /set c4_win=$[c4_win + 1] %;\
      /let x=$[x + 1] %;\
    /else \
      /break %;\
    /endif %;\
  /done %;\
  /if (c4_win >= 4) \
    /return %;\
  /endif %;\
  /set c4_win 1 %;\
  /let x $[%{c4_x} + 1] %;\
  /let y $[%{c4_y} + 1] %;\
  /while ((x <= 7) & (y <= 6)) \
    /eval /set c4_temp=$$(/nth %{y} %%{c4_col%{x}}) %;\
    /if (c4_temp =~ c4_p) \
      /set c4_win=$[c4_win + 1] %;\
      /let x=$[x + 1] %;\
      /let y=$[y + 1] %;\
    /else \
      /break %;\
    /endif %;\
  /done %;\
  /let x $[%{c4_x} - 1] %;\
  /let y $[%{c4_y} - 1] %;\
  /while ((x > 0) & (y > 0)) \
    /eval /set c4_temp=$$(/nth %{y} %%{c4_col%{x}}) %;\
    /if (c4_temp =~ c4_p) \
      /set c4_win=$[c4_win + 1] %;\
      /let x=$[x - 1] %;\
      /let y=$[y - 1] %;\
    /else \
      /break %;\
    /endif %;\
  /done %;\
  /if (c4_win >= 4) \
    /return %;\
  /endif %;\
  /set c4_win 1 %;\
  /let x $[%{c4_x} - 1] %;\
  /let y $[%{c4_y} + 1] %;\
  /while ((x > 0) & (y <= 6)) \
    /eval /set c4_temp=$$(/nth %{y} %%{c4_col%{x}}) %;\
    /if (c4_temp =~ c4_p) \
      /set c4_win=$[c4_win + 1] %;\
      /let x=$[x - 1] %;\
      /let y=$[y + 1] %;\
    /else \
      /break %;\
    /endif %;\
  /done %;\
  /let x $[%{c4_x} + 1] %;\
  /let y $[%{c4_y} - 1] %;\
  /while ((x <= 6) & (y > 0)) \
    /eval /set c4_temp=$$(/nth %{y} %%{c4_col%{x}}) %;\
    /if (c4_temp =~ c4_p) \
      /set c4_win=$[c4_win + 1] %;\
      /let x=$[x + 1] %;\
      /let y=$[y - 1] %;\
    /else \
      /break %;\
    /endif %;\
  /done %;\
  /if (c4_win >= 4) \
    /return %;\
  /endif

/gDef c4_announceTurn = \
  /if (c4_win >= 4) \
    say Connect 4! %;\
    /if (c4_game == 2) \
      /if (c4_p1 =~ 'You') \
        say I win! I win! %;\
      /else \
        say %{c4_p1} wins! %;\
      /endif %;\
    /else \
      /if (c4_p2 =~ 'You') \
        say I win! I win! %;\
      /else \
        say %{c4_p2} wins! %;\
      /endif %;\
    /endif %;\
    /repeat -2 1 /c4_reset %;\
  /elseif (c4_moves >= 42) \
    say Board full, draw game. %;\
    /set c4_game 0 %;\
  /elseif (c4_game == 1) \
    /if (c4_p1 =~ 'You') \
      say It is Red's turn to move. (Me) %;\
    /else \
      say It is Red's turn to move. (%{c4_p1}) %;\
    /endif %;\
  /elseif (c4_game == 2) \
    /if (c4_p2 =~ 'You') \
      say It is Black's turn to move. (Me) %;\
    /else \
      say It is Black's turn to move. (%{c4_p2}) %;\
    /endif %;\
  /endif

/gDef c4_reset = \
  /unset c4_p1 %;\
  /unset c4_p2 %;\
  /set c4_findPlayers 1 %;\
  /set gameInProg 0 %;\
  /set c4_numPlayer 0 %;\
  /set c4_game 0 %;\
  /set c4_moves 0 %;\
  /set c4_win 0

/gDef c4_place = \
  /eval /set c4_len=$$(/length %%{c4_col%{2}}) %;\
  /if (c4_len < 6) \
    /eval /set c4_col%{2} %%{c4_col%{2}} %1 %;\
    /set c4_moves $[%{c4_moves}+1] %;\
    /c4_dispBoard %;\
    /c4_checkWin %2 %;\
    /set c4_game $[(c4_game == 1) ? 2 : 1] %;\
    /c4_announceTurn %;\
  /else \
    say Invalid move.  Try something else. %;\
  /endif

/set c4_num=  1   2   3   4   5   6   7
/set c4_div=|---------------------------| 

/gDef c4_dispBoard = \
  /c4_makeRow 1 %;\
  /c4_makeRow 2 %;\
  /c4_makeRow 3 %;\
  /c4_makeRow 4 %;\
  /c4_makeRow 5 %;\
  /c4_makeRow 6 %;\
  say %{c4_num} %;\
  say %{c4_div} %;\
  say %{c4_row6} %;\
  say %{c4_div} %;\
  say %{c4_row5} %;\
  say %{c4_div} %;\
  say %{c4_row4} %;\
  say %{c4_div} %;\
  say %{c4_row3} %;\
  say %{c4_div} %;\
  say %{c4_row2} %;\
  say %{c4_div} %;\
  say %{c4_row1} %;\
  say %{c4_div}

/gDef echoBoard = \
  /echo -aB * %{c4_num} %;\
  /echo -aB * %{c4_div} %;\
  /echo -aB * %{c4_row6} %;\
  /echo -aB * %{c4_div} %;\
  /echo -aB * %{c4_row5} %;\
  /echo -aB * %{c4_div} %;\
  /echo -aB * %{c4_row4} %;\
  /echo -aB * %{c4_div} %;\
  /echo -aB * %{c4_row3} %;\
  /echo -aB * %{c4_div} %;\
  /echo -aB * %{c4_row2} %;\
  /echo -aB * %{c4_div} %;\
  /echo -aB * %{c4_row1} %;\
  /echo -aB * %{c4_div}  

/gDef c4_makeRow = \
  /set c4_row%{1} | %;\
  /c4_piece c4_row%{1} $(/nth %{1} %{c4_col1}) %;\
  /c4_piece c4_row%{1} $(/nth %{1} %{c4_col2}) %;\
  /c4_piece c4_row%{1} $(/nth %{1} %{c4_col3}) %;\
  /c4_piece c4_row%{1} $(/nth %{1} %{c4_col4}) %;\
  /c4_piece c4_row%{1} $(/nth %{1} %{c4_col5}) %;\
  /c4_piece c4_row%{1} $(/nth %{1} %{c4_col6}) %;\
  /c4_piece c4_row%{1} $(/nth %{1} %{c4_col7})

/gDef c4_piece = \
  /if (%{2} =~ 'R') \
    /eval /set %{1}=$$[strcat(%{1}, "(R)|")] %;\
  /elseif (%{2} =~ 'B') \
    /eval /set %{1}=$$[strcat(%{1}, " B |")] %;\
  /else \
    /eval /set %{1}=$$[strcat(%{1}, "   |")] %;\
  /endif
