; Makepath.tf
; A quicker and more intelligent /dopath.
;
; Questions, comments, criticisms to Symbolic.
;
; Initial Values of Preferences:
	/set DisplayConverts=0
; End Preference Declarations

/load util.tf

/def switcharrow = /let args=%*%;/echo -- <-$[substr(args,2)]

/def convert_all = \
	/mpecho * Creating All Undefined Return Paths . . . %; \
	/eval /_convert_all $(/list -i -- ->)

/def -i _convert_all = \
	/while /test {#} %; /do \
		/while /test {1} !/ "%%" & {#} %;/do \
			/shift %; \
		/done %;\
		/if /test {#} < 5 %; /then \
			/shift %;\
			/break %;\
		/endif %;\
		/let PlaceName=$(/switcharrow %{5} ) %; \
		/if /test !uMacroExist("%{PlaceName}") %; /then \
			/if /test {DisplayConverts} %; /then \
				/echo -aB * Creating Location: %{PlaceName} %; \
			/endif %; \
			/eval /convert %{5} %; \
		/endif %; \
		/shift %; \
	/done

/def convert = /set crPath=%;/eval /revpath  $$\{%*\}%;\
	/eval /mpdef  $(/switcharrow %*) = %{crPath}

/set crPath=

/def -i revpath = \
	/if /test {L2} != 0 & {#} >=2 %; /then \
		/set crPath=%{crPath} %{L2}%;\
		/revdir %L%;\
		/revpath %-L2%;\
	/elseif /test {#}%; /then \
       		/let x=$[substr(%L,0,2)] %;\
       		/if /test (x =~ "->") %; /then \
			/set crPath=%{crPath} $(/switcharrow %L)%;\
		/else \
			/revdir %L%;\
			/revpath %-L1%;\
		/endif%;\
	/endif

/def -i revdir = \
	/let dir=%1%;\
	/set crPath=%{crPath} $(/_return_aux2 n s e w u d )

/def -i _return_aux2 = \
	/if /test {#} == 0%; /then \
		/NOP%;\
	/elseif /test dir =~ "%1"%;/then \
		/echo %2%;\
	/elseif /test dir =~ "%2"%;/then \
		/echo %1%;\
	/else \
		/_return_aux2 %-2%;\
	/endif

/def -i mpDef = /def -i -- %{*}
/def -i mpDef2 = /def -i -- mp%{*}
/set cmpPath=
/set moveQ=
/set inMotion=0
/def apath = \
	/set ndir=%1%;\
	/eval /set tdir=\$\(/LAST %{cmpPath}\) %;\
	/if /eval /test "$(/mpCancelPath n s e w u d )"=~""%;/then \
		/eval /set cmpPath=\$\(/all_but_last %{cmpPath}\)%;\
	/else \
		/if /test cmpPath =~ ""%;/then \
			/set cmpPath=%1%;\
		/else \
			/set cmpPath=%{cmpPath} %1%;\
		/endif%;\
	/endif

/def -iFp99999 -mglob -h'send {n|s|e|w|u|d}' _mp_hook = \
	/if /test (moveQ =~ "" & inMotion == 0)%;/then \
		/if /test "%{1}"=/"%{curExits}"%;/then \
			/apath %1%;\
			/set inMotion=1%;\
		/endif%;\
	/else \
		/uPutQ %{*} moveQ%;\
	/endif

/def -i -mglob -h'send {n|s|e|w|u|d}' _mp_send = \
	/send %*
/def tp1
/def -t'You try to peek' PeekWarning = \
	/def -1 -ip9999 -t'Obvious Exits:' PeekExits = /undef NoPeek %; \
	/def -1 -Fip9999 -t'<Adventure.*>' NoPeek = /undef PeekExits
/def -iFp999 -mregexp -t'Obvious Exits:( \[(north|east|south|west|up|down)\])+' roomtrig = \
	/set inMotion=0%;\
	/while /test {1} !/ "\\[*\\]" & {#} %;/do \
		/shift %;\
	/done%;\
	/set curExits={%;\
	/while /test {1} =/ "\\[*\\]" & {#} %;/do \
		/let thisdir=%;\
		/if /test {1}=~"[north]"%;/then \
			/let thisdir=n%;\
		/elseif /test {1}=~"[south]"%;/then \
			/let thisdir=s%;\
		/elseif /test {1}=~"[down]"%;/then \
			/let thisdir=d%;\
		/elseif /test {1}=~"[up]"%;/then \
			/let thisdir=u%;\
		/elseif /test {1}=~"[east]"%;/then \
			/let thisdir=e%;\
		/elseif /test {1}=~"[west]"%;/then \
			/let thisdir=w%;\
		/endif%;\
		/if /test thisdir !~ ""%;/then \
			/set curExits=%{curExits}%{thisdir}|%;\
		/endif%;\
		/shift%;\
	/done%;\
	/set curExits=%{curExits}}%;\
	/let keepgoing=1%;\
	/while /test keepgoing%;/do \
		/let keepgoing=0%;\
		/if /test moveQ !~ ""%;/then \
;			/echo NON EMPTY QUEUE%;\
			/let curMove=$(/uGetQ moveQ)%;\
			/if /eval /test "%{curMove}"=/"%{curExits}"%;/then \
				/apath %{curMove}%;\
				/set inMotion=1%;\
			/else \
				/let keepgoing=1%;\
			/endif%;\
		/endif%;\
	/done%;\

; User macros

/mpDef Goto = \
   /if /test "%{2}"=~"from" %; /then \
       /set mpTempLoc=%{3} %;\
    /else \
       /set mpTempLoc=%{mpCurLoc} %;\
    /endif %;\
   /if /test mpTest("%{1} ->") %; /then /break %; /endif %;\
;   /if /test mpTest("%{mpTempLoc} <-") %; /then \
;	/eval /eval /mpdef <-%{mpTempLoc} = \$\[/revpath ->%{mpTempLoc}]%;\
;	/break %;\
;   /endif %;\
   /DoMove <-%{mpTempLoc} ->%{1} %;\
   /set mpCurLoc=%{1} %;\
   /set cmpPath=%;\
   /set moveQ=

/mpDef To = \
   /if /test mpTest("%{1} ->") %; /then /break %; /endif %;\
   /DoMove ->%{1} %;\
   /set mpCurLoc=%{1} %;\
   /set cmpPath=%;\
   /set moveQ=

/mpDef From = \
   /if /test mpTest("%{1} <-") %; /then /break %; /endif %;\
   /DoMove <-%{1} %;\
   /set mpCurLoc=HoJ %;\
   /set cmpPath=%;\
   /set moveQ=

/mpDef PrintMove = \
   /set crPath= %;\
   /revpath %{cmpPath} %; \
   /set mpCurPath=%{crPath} %;\
   /mpDoMove %{*} %;\
   /echo %{mpCurPath}

/mpDef DoMove = \
   /set crPath= %;\
   /revpath %{cmpPath} %; \
   /set mpCurPath=%{crPath} %;\
   /mpDoMove %{*} %;\
   /mpGo %{mpCurPath}

/mpDef Where = \
   /mpecho Current location: %{mpCurLoc} %{cmpPath}

/mpDef setWhere = \
	/if /test ! {#} %; /then \
		/mpecho Please specify where you are. %; \
		/break %; \
	/endif %; \
	/if /test !mpTest("%{1} ->") & !mpTest("%{1} <-") %; /then \
		/set mpCurLoc=%{1} %; \
		/shift %; \
		/if /test {*} =~ "" %; /then \
			/set cmpPath=%; \
		/else \
			/set cmpPath=%{*} %;\
		/endif %;\
	/endif

/mpDef whenNoQ = \
	/if /test {1} =/ "-t" %; /then \
		/shift %; \
		/if /test {1} < 1 %; /then \
			/echo Please specify a time greater than 0. %; \
			/break %; \
		/endif %; \
		/set NoQWaitTime=%{1} %; \
		/shift %; \
	/elseif /test !{NoQWaitTime} %; /then \
		/set NoQWaitTime=60 %; \
	/endif %; \
	/if /test {moveQ} =~ "" %; /then \
		/eval %{*} %; \
		/break %; \
	/endif %; \
	/repeat -%{NoQWaitTime} 1 /whenNoQ %{*} 

; Internal macros

/mpDef2 Go = \
   /let mpGoTemp= %;\
   /while /test %{#} %; /do \
      /let mpGoTemp=$[strcat(%{mpGoTemp},%{1},"\\10")] %;\
      /shift %;\
   /done %;\
   /eval %{mpGoTemp}

/mpDef2 DoMove = \
   /while /test %{#} %; /do \
       /let x=$[substr(%1,0,2)] %;\
       /if /test (x =~ "->" | x =~ "<-") %; /then \
               /if /test mpTest("%{1}") %; /then %;\
                   /set mpCurPath= %;\
                   /break %;\
                /endif %;\
               /eval /mpDoMove $${%{1}} %;\
               /shift %;\
       /elseif /test %{1} != 0 %; /then \
           /for i 1 %1 /mpAddPath %2 %;\
           /shift 2 %;\
        /else \
           /mpAddPath %{1} %;\
           /shift %;\
        /endif %;\
   /done

/mpDef2 AddPath = \
   /set tdir=$(/clst %{mpCurPath}) %;\
   /set ndir=%{1} %;\
   /let result=$(/mpCancelPath n s e w u d ) %;\
   /if /test result =~ "" %; /then \
       /set mpCurPath=$(/nlst %{mpCurPath}) %;\
    /else \
       /set mpCurPath=%{mpCurPath} %{ndir} %;\
    /endif

/mpDef2 CancelPath = \
   /if /test %# == 0 %; /then \
       /echo -- %{ndir} %;\
   /elseif /test (tdir =~ "%1" & ndir =~ "%2") %; /then \
           /NOP %;\
   /elseif /test (tdir =~ "%2" & ndir =~ "%1") %; /then \
           /NOP %;\
   /else /mpCancelPath %-2 %;\
   /endif

/mpDef2 Test = \
   /if /test !uMacroExist("%{2}%{1}") %; /then \
       /mpecho Location %{2}%{1} unknown. %;\
    /endif %;\
   /test !uMacroExist("%{2}%{1}")

/mpDef clst = /echo -- %L1
/mpDef nlst = /echo -- %-L1

/mpDef2 Echo = /echo -aB -- * %{*}

/mpDef2 Help = \
   /mpecho %;\
   /mpecho Makepath.tf Help %;\
   /mpecho %;\
   /mpecho /to Loc               - Moves you from HoJ to Loc. %;\
   /mpecho /from Loc             - Moves you from Loc to HoJ. %;\
   /mpecho /goto Loc (from Loc2) - Moves you from current location to Loc. %;\
   /mpecho /domove path          - Works like /dopath only faster. %;\
   /mpecho /where                - Shows you where makepath.tf thinks you are. %;\
   /mpecho %;\
   /mpecho /mpdef ->Loc = path   - Define a to Loc macro. %;\
   /mpecho /mpdef <-Loc = path   - Define a from Loc macro. %;\
   /mpecho %;\
   /mpecho Note path can be single directions (n, s, e), a repeated %;\
   /mpecho direction (4 n, 3 s), even to/from macros (->augustina, %;\
   /mpecho <-wynt). %;\
   /mpecho

; Quit macro

/mpDef2 Quit = /purge -i clst %;\
              /purge -i nlst %;\
              /purge -i mp* %;\
              /echo * Makepath.tf removed.

; Startup message

/mpecho Makepath.tf ready.
/mpecho Questions, comments, criticisms to Symbolic.

