/set mb_blur=1
/set mb_ss=1
/set mb_ssthres=100
/set mb_cc=1
/set mb_ccthres=100
/set mb_armor=1
/set mb_armortype=general
/set mb_aegis=1
/set mb_aegistype=general
/set mb_aura=0

/def -i Buff = \
	/if (mb_blur) /let mb_a=blur %;/endif %;\
	/if (mb_cc) /let mb_b=\\10corona %mb_ccthres %;/endif %;\
	/if (mb_ss) /let mb_c=\\10stoneskin %mb_ssthres %;/endif %;\
	/if (mb_aegis) /let mb_d=\\10aegis %mb_aegistype %;/endif %;\
	/if (mb_armor) /let mb_e=\\10armor %mb_armortype %;/endif %;\
	/if (mb_aura) /let mb_f=\\10aura %;/endif %;\
	/eval %mb_a%mb_b%mb_c%mb_d%mb_e%mb_f

/def -i BuffHelp = \
	/echo -aB * MageBuff Help %;\
	/echo -aB * %;\
	/echo -aB * /Buff       Attempt to cast mage buffs (repeat to cast all) %;\
	/echo -aB * /BuffList   Lists the current buffs that will cast %;\
	/echo -aB * /BuffSet    Sets up the list of buffs %;\
	/echo -aB * /BuffClear  Clear current buffs on list %;\
	/echo -aB * %;\
	/echo -aB * /BuffSet blur (off|on)%;\
	/echo -aB * /BuffSet corona (off|threshold)%;\
	/echo -aB * /BuffSet stoneskin (off|threshold)%;\
	/echo -aB * /BuffSet aegis (off|type)%;\
	/echo -aB * /BuffSet armor (off|type)%;\
	/echo -aB * /BuffSet aura (off|on)

/def -i BuffList = \
	/echo -aB * Buff List %;\
	/echo -aB * %;\
	/if (mb_blur) \
		/echo -aB * Blur %;\
	/endif %;\
	/if (mb_cc) \
		/echo -aB * Corona %mb_ccthres %;\
	/endif %;\
	/if (mb_ss) \
		/echo -aB * Stoneskin %mb_ssthres %;\
	/endif %;\
	/if (mb_aegis) \
		/echo -aB * Aegis %mb_aegistype %;\
	/endif %;\
	/if (mb_armor) \
		/echo -aB * Armor %mb_armortype %;\
	/endif %;\
	/if (mb_aura) \
		/echo -aB * Aura %;\
	/endif

/def -i BuffClear = \
	/if (mb_cc) dispel corona %;/endif %;\
	/if (mb_ss) dispel stoneskin %;/endif %;\
	/if (mb_aegis) dispel aegis %;/endif %;\
	/if (mb_armor) dispel aura %;/endif %;\

/def -i BuffSet = \
  /if ({1} =~ "blur") \
		/if (({2} =~ "off" | {2} == 0) & {2} !~ "on") \
			/set mb_blur=0 %;/else /set mb_blur=1 %;\
		/endif %;\
  /elseif ({1} =~ "corona") \
		/if ({2} =~ "off") \
			/set mb_cc=0 %;\
		/else \
			/set mb_cc=1 %;\
			/set mb_ccthres=%2 %;\
		/endif %;\
  /elseif ({1} =~ "stoneskin") \
		/if ({2} =~ "off") \
			/set mb_ss=0 %;\
		/else \
			/set mb_ss=1 %;\
			/set mb_ssthres=%2 %;\
		/endif %;\
  /elseif ({1} =~ "aegis") \
		/if ({2} =~ "off") \
			/set mb_aegis=0 %;\
		/else \
			/set mb_aegis=1 %;\
			/set mb_aegistype=%2 %;\
		/endif %;\
  /elseif ({1} =~ "armor") \
		/if ({2} =~ "off") \
			/set mb_armor=0 %;\
		/else \
			/set mb_armor=1 %;\
			/set mb_armortype=%2 %;\
		/endif %;\
  /elseif ({1} =~ "aura") \
		/if (({2} =~ "off" | {2} == 0) & {2} !~ "on") \
			/set mb_aura=0 %;/else /set mb_aura=1 %;\
		/endif %;\
  /endif

/def -i -ahCwhite -mregexp \
	-t'[> ]*Your protective armor aura fails\.\.\.$' mb_gone =
/def -i -ahCwhite -mregexp \
	-t'[> ]*Your protective aegis fails\.\.\.$' mb_gone2 =
/def -i -ahCwhite -mregexp \
	-t'[> ]*Your protective corona vanishes\.$' mb_gone3 =
/def -i -ahCwhite -mregexp \
	-t'[> ]*Your skin feels less weird\.$' mb_gone4 =
/def -i -ahCwhite -mregexp \
	-t'[> ]*The sparkling field floats away on a breeze\.$' mb_gone5 =
/def -i -ahCwhite -mregexp \
	-t'[> ]*Suddenly, the world comes back into focus\.$' mb_gone6 = 
/def -i -ahCwhite -mregexp \
	-t'[> ]*Your thick skin takes the blow, then becomes normal again\.' mb_ssgone =
/def -i -ahCwhite -mregexp \
	-t'[> ]*The corona blazes brightly, then fades away\.$' mb_ccgone =
