;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;   Generic Error Messages
/def -p2 -t"* to cast this spell." auto_sp = %{auto_talk} Sorry! I'm out of SP! :-( 

/def -p2 -t"* from that room!" auto_tpproof = tell %{auto_target} You're in a Tp-Proof room!

/def -p2 -t"* is already under a spell of protection." auto_armor_already = "Silly %{auto_target}, you're already Armored!

;/def -p2 -t"* engaged this round." auto_engaged = "I was already engaged that round, sorry...

/def -p2 -t"* is already protected by this spell." auto_skin_already = "Silly %{auto_target}, you're already stoneskinned!

/def -p2 -t"* and drag * through!" auto_goodsummon = "Tah-Dah! %; hug %{auto_target} 

/def auto_fizzle
/def -i auto_sigil = sigil "armor {crushing|slashing|thrusting|general}, stoneskin, featherfall, tell namrepus summon"
;/auto_sigil
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    Triggers 
;/def -i -t"* arrives." auto_arrive  = raise %1

;;;;;;;;;;;;;;;; Summon
/def -p2 -t"* tells you: {summon}*" auto_summon = \
	/set auto_talk=reply%;\
	/set auto_target=%1%;\
	/undef auto_fizzle%;\
	/def -t"* but it goes awry." auto_fizzle = reply Doh! I failed! Try again. :-(%;\
	summon %{auto_target} 

;;;;;;;;;; Different Armors 
/def -p2 -t"* says: armor slashing*" auto_as = \
	/set auto_talk=say%;\
	/set auto_target=%1%;\
	/undef auto_fizzle%;\
	/def -t"* even as you speak it." auto_fizzle = emote stares in disbelief as his armor spell on %{auto_target} goes amuck. %;\
	armor slashing on %{auto_target} 

/def -p2 -t"* says: armor crushing*" auto_ac =  \
	/set auto_talk=say%;\
	/set auto_target=%1%;\
	/undef auto_fizzle%;\
	/def -t"* even as you speak it." auto_fizzle = emote stares in disbelief as his armor spell on %{auto_target} goes amuck. %;\
	armor crushing on %{auto_target} 

/def -p2 -t"* says: armor thrusting*" auto_at = \
	/set talk=say%;\
	/set auto_target=%1%;\
	/undef auto_fizzle%;\
	/def -t"* even as you speak it." auto_fizzle = emote stares in disbelief as his armor spell on %{auto_target} goes amuck. %;\
	armor thrusting on %{auto_target} 

/def -p2 -t"* says: armor general*" auto_ag = \
	/set talk=say%;\
	/set auto_target=%1%;\
	/undef auto_fizzle%;\
	/def -t"* even as you speak it." auto_fizzle = emote stares in disbelief as his armor spell on %{auto_target} goes amuck. %;\
	armor general on %{auto_target} 

;;;;;;;;;;;; Stoneskin Spell

/def -p2 -t"* says: stoneskin*" auto_stoneskin = \
	/set talk=say%;\
	/set auto_target=%1%;\
	/undef auto_fizzle%;\
	/def -t"*know even as you cast it that it will fail." auto_fizzle = :cannot believe that he failed to cast stoneskin on %{auto_target}!%;\
	stoneskin %{auto_target}

;;;;;;;;;;;; Featherfall Spell

/def -p2 -t"* says: featherfall*" auto_featherfall = \
	/set talk=say%;\
	/set auto_target=%1%;\
	/undef auto_fizzle%;\
	/def -t"The spell fails." auto_fizzle = :cannot believe that he failed to cast featherfall on %{auto_target}!%;\
	featherfall %{auto_target}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;    Turns off all mage triggers.
/def -p1 auto_off = /purge auto* %; describe is a mysterious person. As you look upon  him, you see only long flowing robes and cloak. Under this cloak you see a face of power.
