;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;            mvp.tf            ;;
;; Written by Milkyway 09/09/97 ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

/if /test mvpState == 0 %; /then \
  /set mvpState=0 %;\
  /set startTime=0 %;\
/endif

/echo
/echo -aB ## Mvp trigs loaded.
/echo -aB ## Type "score" to set your starting xp and time,
/echo -aB ## or "/mvphelp" for more information.

/def -i -Fp99999 -ag -mregexp -t'EXPERIENCE   : ([0-9]*) *TO SPEND' exp_trig = \
      /if /test mvpState==0 %; \
         /then /set startXp=%P1%; \
               /eval /set startTime=$(/time @)%; \
               /set mvpState=1%; \
               /echo -p %{*}    (Starting xp set.) %; \
      /elseif /test mvpState==1 %; \
         /then /set endXp=%P1%; \
               /echo %{*} %;\
      /endif

/def -i -Fp99999 -mregexp -t'XP : ([0-9]*) *\(.* left to spend\)' exp_trig2 = \
      /if /test mvpState==0 %; \
         /then /set startXp=%P1%; \
               /eval /set startTime=$(/time @)%; \
               /set mvpState=1%; \
      /elseif /test mvpState==1 %; \
         /then /set endXp=%P1%; \
      /endif

; The macro that does all the work...
/def -i mvp = \
   /eval /set endTime=$(/time @)%;\
   /if /test startTime==0%; \
      /then /eval /set startTime=$[endTime-1]%; \
   /endif%; \
   /eval /set elapsedTime=$[(endTime-startTime)]%; \
   /eval /set gainedXp=$[endXp-startXp]%; \
   /if /test %{gainedXp}<=0%; \
      /then /set gainedXp=0%; \
   /endif%; \
   /eval /echo -aB ** MVP Info:  Time: $(/SecondsToMinSeconds $[elapsedTime]), XP: $[gainedXp/1000]k, Rate: $[(gainedXp/elapsedTime*36/10)]kxp/hr

/def -i mvpreset = \
   /eval /set startTime=$(/time @)%; \
   /eval /set mvpState=0%; \
   /echo ## Mvp data has been reset.%; \
   /echo ## Type "score" to set new data.

/def -i mvpstop = \
   /undef mvphelp%; \
   /undef exp_trig%; \
   /undef mvpreset%; \
   /undef mvp %; \
   /undef mvpstop%; \
   /eval /echo  ## All mvp macros undefined.

/def -i mvphelp = \
   /echo %; \
   /echo ## Mvp help:%; \
   /echo ## When you type "score" for the first time after loading mvp.tf,%; \
   /echo ## your initial xp and starting time are set.  After this, typing%; \
   /echo ## "score" will update your xp gained since setting your starting xp.%; \
   /echo ##%; \
   /echo ## Once mvp.tf knows your initial and updated xp, and your starting%; \
   /echo ## time, "/mvp" will calculate and display your mvp data.%; \
   /echo ##%; \
   /echo ## Should you wish to reset your mvp and begin fresh calculations%; \
   /echo ## from a new starting time, type "/mvpreset".  To stop using mvp.tf,%; \
   /echo ## and unload all of its macros from memory, type "/mvpstop".%; \
   /echo
