;
; TF Backstab Reporting Trigs by F/Lois
;
; usage: /load this file, then:
;        /runbsmacro <macroThatInOuts> (Do not add the / )
;        
; Requires Util.tf 0.8 preferred... some earlier versions should work
;

/def -i bsQuit = /purge -i bs*

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Customizable settings
/set bsSayMethod=party
/set bsWhiffMessage=Whiffed.
/set bsDeathMessage=BAM!
/set bsTurnedMessage=Turned.


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
/def -i repLine = /set bsSayMethod %*


/if /test util_tf < 8%;/then \
	/echo -aB % Warning: Rep.tf may not work without Util.tf 0.8 or greater!%;\
/endif	

/if /test !uMacroExist("NOP")%;/then /def -i NOP%;/endif


;/def -mregexp -t'>>> .* is now ([a-zA-Z\'. ]+)(<<<|)$' bsSawChange = \
/def -i -mregexp -t'>>> .* is now ([^<]+)(<<<|)$' bsSawChange = \
	 /set bsWasChange=1%;/set bsStage=%P1

/def -i -p999999999 -mregexp -F -t'[A-Za-z ]* died.' bsSawDeath = /set bsWasChange=1%;/set bsStage=%{bsDeathMessage}

/def -i -p999999    -mregexp -F -t'(Slar gasps its|turns to vapor)' bsSawFunkyDeathMessage = /set bsWasChange=1%;/set bsStage=%{bsDeathMessage}

/def -i -Fp9999 -t'*you creep*behind*' bsTried = /set bsTriedBs=1

/def -i -Fp9999 -t'*attempt to creep*turns*' bsNoticed = /set bsNoticed=1

/def -i -Fp9999 -t'*turns on you at the last moment!' bsSawTurned = \
   /if /test bsTriedBs %;/then /set bsTurned=1 %;/endif

/def -i -Fp9999 -mregexp -t'\((x[0-9][0-9\+]*).*\)' bsSawCrit = \
  /if /test bsCrits =~ ""%;/then \
    /set bsCrits=%P1 %;\
  /else \
    /set bsCrits=%{bsCrits} %P1 %;\
  /endif


/def -i bsResetVars = /set bsWasChange=0%;/set bsMiss=0%;/set bsTurned=0%;/set bsCrits=%;/set bsNoticed=0%;/set bsTriedBs=0
 
/def -i bsReport = \
        /if /test bsTurned == 1%;/then \
                %{bsSayMethod} %{bsTurnedMessage}%;\
        /elseif /test bsNoticed == 1%;/then \
                /NOP %;\
        /elseif /test bsWasChange == 1 & bsCrits!~""%;/then \
                %{bsSayMethod} %{bsCrits} %{bsStage}%;\
        /elseif /test bsTriedBs=1 & bsCrits!~""%;/then \
                %{bsSayMethod} %{bsCrits} : No Change.%;\
        /elseif /test bsTriedBs=1%;/then \
                %{bsSayMethod} %{bsWhiffMessage}%;\
        /endif

/def -i runbsmacro = /bsresetvars%;/uaputq bsreport%;/eval /%{*}%;,


