; Warstore.tf: Menu system for OD warstore;
; Syntax: /buywep - to buy a warstore weapon
;         /buyarmor - to buy a warstore armor piece.
; Written by 'F' :)




/def waitinput = \
	/def -n1 -h'SEND [0-9]*' getinput = /set wsInput=%%*%%;/processinput

/def processinput = \
	/eval /set wsOrder=%{wsOrder} %{wsInput}%;\
	/eval /set wsNum=$[wsNum+1]%;\
	/if /test wsNum > 6%;/then \
		/eval order %{wsOrder}%;\
		/echo -aB * Ordering %{wsOrder}%;\
	/else \
		/if /test wsType =~ 'wep'%;/then \
			/eval /dowep %{wsNum}%;\
		/else \
			/eval /doarmor %{wsNum}%;\
		/endif%;\
	/endif

/def buywep = /set wsType=wep%;/set wsNum=2%;/set wsOrder=0%;/dowep 2
/def buyarmor = /set wsType=armor%;/set wsNum=2%;/set wsOrder=1%;/doarmor 2

; Takes current num

/def dowep = /if /test %{1} = 2%;/then \
		/echo -aCred * (0) Axe (1) Bow (2) Dagger (3) Mace (4) Polearm (5) Staff (6) Sword%;\
		/waitinput%;\
	    /elseif /test %{1} = 3%;/then \
		/echo -aCred * (0) One-Handed (1) Two-Handed%;\
		/waitinput%;\
	    /elseif /test %{1} = 4%;/then \
		/echo -aCred * (0) Bad (1) Poor (2) Average (3) Excellent (4) Miraculous%;\
		/waitinput%;\
	    /elseif /test %{1} = 5%;/then \
		/echo -aCred * (0) None (1) Str (2) Int (3) Wis (4) Dex %;\
		/waitinput%;\
	    /elseif /test %{1} = 6%;/then \
		/echo -aCred * (0) None (1) Fire (2) Cold (3) Shock (4) Acid (5) Poison (6) Energy (7) Magic%;\
		/waitinput%;\
	    /endif

/def doarmor = /if /test %{1} = 2%;/then \
		/echo -aCred * (0) Body (1) Gloves (2) Boots (3) Neck (4) Belt (5) Helmet (6) Ring %;\
		/echo -aCred = (7) Shield (8) Cloak%;\
		/waitinput%;\
	    /elseif /test %{1} = 3%;/then \
		/echo -aCred * (0) Light (1) Heavy%;\
		/waitinput%;\
	    /elseif /test %{1} = 4%;/then \
		/echo -aCred * (0) Bad (1) Poor (2) Average (3) Excellent (4) Miraculous%;\
		/waitinput%;\
	    /elseif /test %{1} = 5%;/then \
		/echo -aCred * (0) None (1) Str (2) Int (3) Wis (4) Dex %;\
		/waitinput%;\
	    /elseif /test %{1} = 6%;/then \
		/echo -aCred * (0) None (1) Fire (2) Cold (3) Shock (4) Acid (5) Poison%;\
		/echo -aCred = (6) Energy (7) Magic (8) Thrusts (9) Cuts (10) Blows%;\
		/waitinput%;\
	   /endif
