/def dqload = \
  /load ~/tfstuff/death.tf
/def dqtest = \
  /trigger You have died.
/def -iFp99 -mregexp -t'^[> ]*([A-Za-z]*) tells you: dq_end$' DQsafety = /DQ_end

/set DQdead 0

/def -iFp99 -mregexp -t'^[> ]*Brief mode.$' DQ_lmode= \
  /if (DQdead==0) /return %;/endif %;\
  /set DQprevmode=0 %;\
  brief

/def -iFp99 -mregexp -t'^[> ]*You have died\.$' DQ_start = \
  /set DQprevmode=1 %;\
  /set DQdead=1 %;\
  /set DQspire=1 %;\
  /set DQpause=0 %;\
  /set DQskew=0 %;\
  /set DQbuffer= %;\
  /echo -aB Attempting death quest.  Type /dq_end to cancel %;\
  brief %;\
  look

;You feel a tremendous pulling and soon find yourself back in the world of the living.
/def -iFp99 -mregexp -t'^[> ]*You feel a tremendous pulling and soon find yourself back' DQ_end = \
  /if (DQdead==0) /return %;/endif %;\
  /set DQdead 0 %;\
  /if (DQprevmode==1) brief %;/set DQprevmode=0 %;/endif

/def -i DQ_valid = \
  /if ({1} =/ DQpaths) \
    /echo 1 %;\
  /else \
    /echo 0 %;\
  /endif

/def  -i DQ_loop = \
  /if ({1} =/ DQpaths) \
    /eval /echo $(/DQ_check %1) %;\
  /else \
    /echo -- -1 %;\
  /endif

/def -i DQ_cw = \
  /if ({1} =~ "north") /echo northeast %;\
  /elseif ({1} =~ "northeast") /echo east %;\
  /elseif ({1} =~ "east") /echo southeast %;\
  /elseif ({1} =~ "southeast") /echo south %;\
  /elseif ({1} =~ "south") /echo southwest %;\
  /elseif ({1} =~ "southwest") /echo west %;\
  /elseif ({1} =~ "west") /echo northwest %;\
  /else /echo north %;\
  /endif
/def -i DQ_ccw = \
  /if ({1} =~ "north") /echo northwest %;\
  /elseif ({1} =~ "northwest") /echo west %;\
  /elseif ({1} =~ "west") /echo southwest %;\
  /elseif ({1} =~ "southwest") /echo south %;\
  /elseif ({1} =~ "south") /echo southeast %;\
  /elseif ({1} =~ "southeast") /echo east %;\
  /elseif ({1} =~ "east") /echo northeast %;\
  /else /echo north %;\
  /endif

/def -i DQ_skew = \
  /for i 1 %DQskew /eval /set DQdir=$$(/DQ_ccw %%{DQdir}) %;\
  /if (DQskew) \
    /set DQskew $[DQskew - 1] %;\
  /endif

/def -i DQ_cont = \
  /set DQpause=0 %;\
  look

/def -i DQ_check = \
  /eval /set DQbuf=%1 %DQbuffer %;\
  /set DQx=0 %;\
  /set DQy=0 %;\
  /set DQcheck=0 %;\
  /eval /set DQlen=$(/length %DQbuf) %;\
  /for i 1 %DQlen \
    /let n=$$(/nth %%i %%DQbuf) %%;\
    /if (%%n =/ 'north') //eval //set DQy=$$[DQy+1] %%;\
    /elseif (%%n =/ 'south') //eval //set DQy=$$[DQy-1] %%;\
    /elseif (%%n =/ 'east') //eval //set DQx=$$[DQx+1] %%;\
    /elseif (%%n =/ 'west') //eval //set DQx=$$[DQx-1] %%;\
    /elseif (%%n =/ 'northeast') //eval //set DQx=$$[DQx+1] %%;\
                                 //eval //set DQy=$$[DQy+1] %%;\
    /elseif (%%n =/ 'northwest') //eval //set DQx=$$[DQx-1] %%;\
                                 //eval //set DQy=$$[DQy+1] %%;\
    /elseif (%%n =/ 'southeast') //eval //set DQx=$$[DQx+1] %%;\
                                 //eval //set DQy=$$[DQy-1] %%;\
    /elseif (%%n =/ 'southwest') //eval //set DQx=$$[DQx-1] %%;\
                                 //eval //set DQy=$$[DQy-1] %%;\
    /endif %%;\
    /if (%%DQx == 0 & %%DQy == 0) \
      /set DQcheck %%i %%;/break %%; \
    /endif %;\
  /echo %DQcheck

/def -i DQ_add = \
  /echo -aB Trying to go %1.  Type /dq_end to cancel. %;\
  /eval /set DQbuffer=$(/DQ_chop %1 %DQbuffer)
/def -i DQ_chop = \
  /set DQbuffer=%1 %2 %3 %4 %5 %6 %7 %8 %;\
  /echo %DQbuffer

/def -i DQ_move = \
  /if (DQpause) /return %;/endif %;\
  /if (DQdir =~ "up") \
   climb spire %;\
    /DQ_end %;\
    /return %;\
  /endif %;\
  /eval /set DQok=$(/DQ_loop %{1}) %;\
  /if (DQok==0) \
    /DQ_add %{1} %;\
    /repeat -2 1 %{1} %;\
  /else \
    /eval /set DQaltdir=$(/DQ_cw %{1}) %;\
    /eval /set DQok=$(/DQ_loop %{DQaltdir}) %;\
    /if (DQok==0) \
      /DQ_add %{DQaltdir} %;\
      /repeat -2 1 %{DQaltdir} %;\
    /else \
      /eval /set DQaltdir=$(/DQ_ccw %{1}) %;\
      /eval /set DQok=$(/DQ_loop %{DQaltdir}) %;\
      /if (DQok==0) \
        /DQ_add %{DQaltdir} %;\
        /repeat -2 1 %{DQaltdir} %;\
      /else \
        /set DQskew=2 %;\
;        /set DQskew=$[DQskew+2] %;\
;        /if (DQskew > 3) /set DQskew=3 %;/endif %;\
        /eval /set DQaltdir=$(/DQ_ccw %{DQaltdir}) %;\
        /eval /set DQok=$(/DQ_loop %{DQaltdir}) %;\
        /if (DQok==0) /DQ_move %DQaltdir %;/return %;/endif %;\
        /eval /set DQaltdir=$(/DQ_ccw %{DQaltdir}) %;\
        /eval /set DQok=$(/DQ_loop %{DQaltdir}) %;\
        /if (DQok==0) /DQ_move %DQaltdir %;/return %;/endif %;\
        /eval /set DQaltdir=$(/DQ_ccw %{DQaltdir}) %;\
        /eval /set DQok=$(/DQ_loop %{DQaltdir}) %;\
        /if (DQok==0) /DQ_move %DQaltdir %;/return %;/endif %;\
        /eval /set DQaltdir=$(/DQ_ccw %{DQaltdir}) %;\
        /eval /set DQok=$(/DQ_loop %{DQaltdir}) %;\
        /if (DQok==0) /DQ_move %DQaltdir %;/return %;/endif %;\
        /eval /set DQaltdir=$(/DQ_ccw %{DQaltdir}) %;\
        /eval /set DQok=$(/DQ_loop %{DQaltdir}) %;\
        /if (DQok==0) /DQ_move %DQaltdir %;/return %;/endif %;\
        /set DQbuffer= %;\
        /DQ_move %DQdir %;\
      /endif %;\
    /endif %;\
  /endif

/def -iFp99 -mregexp -t'^[> ]*You fear to move too quickly' DQ_again = \
  /if (DQdead==0) /return %;/endif %;\
  /repeat -2 1 /DQ_move %DQdir

/def -iFp99 -mregexp -t'^[> ]*A (grand )?spire (looms|rises)[a-z, ]+ ([a-z]+)\.$' DQ_spire = \
  /if (DQspire) \
    /set DQdir=%P3 %;\
  /endif

/def -iFp99 -mregexp -t'^[> ]*The base of a great spire sits here' DQ_spire2 = \
  /if (DQspire) \
    /set DQdir=up %;\
  /endif

;/def -iFp99 -mregexp -t'^[> ]*Your footprints leave to the ([a-z]*)[, ]*([a-z]*)[, ]*([a-z]*)[, ]*([a-z]*)[, ]*([a-z]*)[, ]*([a-z]*)[, ]*([a-z]*)([a-z]*)([a-z]*)\.$' DQ_feet = \
;  /set DQtaken {$(/makepipestr %P1 %P2 %P3 %P4 %P5 %P6 %P7 %P8 %P9)}

/def -iFp99 -mregexp -t'^[> ]*In your mind, you sense an? [a-z-]+(, [a-z-]+)? pedestal to the ([a-z]*)' DQ_ped = \
  /set DQdir=%P2 %;\
  /set DQspire=0 %;\

/def -iFp99 -mregexp -t'^[> ]*In your mind, you sense an? [a-z-]+(, [a-z-]+)? pedestal right next to you.' DQ_ped2 = \
  touch pedestal %;\
  /set DQpause=1 %;\
  /set DQspire=1 %;\
  /repeat -2 1 /DQ_cont

/def -iFp99 -mregexp -t'^[> ]*--  There [a-z ]+ obvious exits:  ([a-z]*)[, ]*([a-z]*)[, ]*([a-z]*)[, ]*([a-z]*)[, ]*([a-z]*)[, ]*([a-z]*)[, ]*([a-z]*)(and)?([a-z]*)' DQ_look = \
  /if (DQdead==0) /return %;/endif %;\
  /set DQpathsR=%P1 %P2 %P3 %P4 %P5 %P6 %P7 %P8 %P9 %;\
  /set DQpaths={$(/makepipestr %P1 %P2 %P3 %P4 %P5 %P6 %P7 %P8 %P9)} %;\
  /set DQnoand=1 %;\
  /if ({P2} =~ "and") /set DQnoand=0 %;\
  /elseif ({P3} =~ "and" & {P4} !~ "") /set DQnoand=0 %;\
  /elseif ({P4} =~ "and" & {P5} !~ "") /set DQnoand=0 %;\
  /elseif ({P5} =~ "and" & {P6} !~ "") /set DQnoand=0 %;\
  /elseif ({P6} =~ "and" & {P7} !~ "") /set DQnoand=0 %;\
  /elseif ({P7} =~ "and" & {P8} !~ "") /set DQnoand=0 %;\
  /elseif ({P8} =~ "and" & {P9} !~ "") /set DQnoand=0 %;\
  /endif %;\
  /DQ_skew %;\
  /if (DQnoand == 0) /DQ_move %DQdir %;/endif
 
/def -iFp99 -mregexp -t'^([a-z]+)[, ]*([a-z]*)[, ]*([a-z]*)[, ]*([a-z]*)[, ]*([a-z]*)(and )?([a-z]*)\.$' DQ_look2 = \
  /if (DQdead==0) /return %;/endif %;\
  /if (DQnoand) \
    /set DQpaths {$(/makepipestr %DQpathsR %P1 %P2 %P3 %P4 %P5 %P6 %P7)} %;\
    /set DQnoand=0 %;\
    /DQ_skew %;\
    /DQ_move %DQdir %;\
  /endif

/def -iFp99 -mregexp -t'^[> ]*--  There is one obvious exit:  ([a-z]+)\.$' DQ_look3 = \
  /if (DQdead==0) /return %;/endif %;\
  /set DQbuffer= %;\
  /DQ_add %P1 %;\
  /repeat -2 1 %{P1}
