; Cards!
; /deck_create #  (create list of cards using # decks)
; /deck_deal      (deal the top card in the deck)
; /deck_dealNS    (deal the card without showing suit)
; /deck_num       (number of cards left in deck)
; /deck_reset     (clear deck)
; /deck           (echo full deck)

/gDef deck = \
  /let deck_temp=$(/deck_num) %;\
  /if (deck_temp > 0) \
    /echo -aB * %{deck} %;\
  /else \
    /echo -aB * Empty %;\
  /endif

/gDef deck_reset = \
  /unset deck

/gDef deck_create = \
  /unset deck %;\
  /unset deck_list %;\
  /for i 1 52 /set deck_list %{1} %%{deck_list} %;\
  /set deck_total=$[%{1}*52] %;\
  /let i=0 %;\
  /while (i < %{deck_total}) \
    /let n=$[rand(1,52)] %;\
    /if ($(/nth %n %deck_list) > 0) \
      /deck_dec %n %;\
      /set deck $(/deck_num2card %n) %{deck} %;\
      /let i=$[i+1] %;\
    /endif %;\
  /done

/gDef deck_dec = \
  /unset deck_temp %;\
  /for i 1 52 \
    /if ({1} == i) \
      /set deck_temp %%{deck_temp} $$[$$(/nth %%{i} %{deck_list})-1] %%;\
    /else \
      /set deck_temp %%{deck_temp} $$(/nth %%{i} %{deck_list}) %%;\
    /endif %;\
  /set deck_list %{deck_temp} %;\
  /unset deck_temp

/gDef deck_num2card = \
  /let deck_cardnum=$[mod(%{1}-1,13)+1] %;\
  /if (deck_cardnum == 1) \
    /let deck_cardnum=A %;\
  /elseif (%{deck_cardnum} == 11) \
    /let deck_cardnum=J %;\
  /elseif (%{deck_cardnum} == 12) \
    /let deck_cardnum=Q %;\
  /elseif (%{deck_cardnum} == 13) \
    /let deck_cardnum=K %;\
  /endif %;\
  /let deck_cardsuit=$[(%{1}-1)/13] %;\
  /if (deck_cardsuit == 0) \
    /let deck_cardsuit=C %;\
  /elseif (%{deck_cardsuit} == 1) \
    /let deck_cardsuit=H %;\
  /elseif (%{deck_cardsuit} == 2) \
    /let deck_cardsuit=D %;\
  /else \
    /let deck_cardsuit=S %;\
  /endif %;\
  /let deck_card=%{deck_cardnum}%{deck_cardsuit} %;\
  /result deck_card

/gDef deck_deal = \
  /let deck_card=$(/car %{deck}) %;\
  /set deck=$(/cdr %{deck}) %;\
  /result deck_card

/gDef deck_dealNS = \
  /let deck_card=$(/car %{deck}) %;\
  /let deck_card=$[substr(deck_card, 0, -1)] %;\
  /set deck=$(/cdr %{deck}) %;\
  /result deck_card 

/gDef deck_num = \
  /result $(/length %{deck})
