; kmvp.tf -- by Ai
; Similar to mvp.tf, this file keeps track of how many kills you
; make in how much time

; captures the kill
/def -i -p500 -F -t'* died.' addkill = \
  /eval /set numkills $[numkills+1]%; \
  /eval /set kcurtime $(/time @)%; \
  /eval /set kdeltatime $[kcurtime-kstarttime]

; this is in case the above trigger gets called mistakenly (someone
; shouts: died., someone complains in a post about how "I died.", etc.
/def subkill = /eval /set numkills = $[numkills - 1]

; gets the starting time
/def -n1 -p100 -F -t'Your last login was from *' getkstart = \
  /set numkills=0%; \
  /set kstarttime=$(/time @)

; show the report
/def -i kmvp = \
  /eval /echo Total kills: %numkills  Minutes Online: $[kdeltatime/60]

/def -i resetkmvp=\
  /set numkills=0%;\
  /eval /set kstarttime=/time @

/def helpkmvp=\
  /echo Kmvp.tf -- by Ai%;\
  /echo --%;\
  /echo Keeps track of how many kills you get in a period of time.%;\
  /echo Usage:%;\
  /echo         \/kmvp      Gives you the report%;\
  /echo         \/subkill   Subtracts one kill%;\
  /echo         \/resetkmvp resets kills and time 
