;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Allycis Locating Macro
; /locfish to use

/def -i vdef = /def -i -Fp10 %{*}

/vdef FF_Reset = \
  /set FF_en=0 %;\
  /set FF_found=0 %;\
  /set FF_needlight=0
/FF_Reset

/vdef LocFish = \
  /FF_Reset %;\
  /set FF_en=1 %;\
  /FF_Search
  
/vdef FF_Report = \
  /if (FF_found !~ "0") \
    /echo -aB * Found at %{FF_found}! %;\
;    party %FF_found %;\
  /elseif (FF_needlight) \
    /echo -aB * Can't Find! Can't See! %;\
  /else \
    /echo -aB * Allycis is nowhere to be seen! %;\
  /endif %;\
  /FF_Reset

/vdef FF_Search = \
  /if (FF_en == 1) /g fish %;dive %;\
  /elseif (FF_en == 2) w %;\
  /elseif (FF_en == 3) sw %;\
  /elseif (FF_en == 4) e %;\
  /elseif (FF_en == 5) s %;\
  /elseif (FF_en == 6) s %;\
  /elseif (FF_en == 7) e %;\
  /elseif (FF_en == 8) n %;\
  /elseif (FF_en == 9) e %;\
  /elseif (FF_en == 10) n %;\
  /elseif (FF_en == 11) n %;\
  /elseif (FF_en == 12) \
    w\10climb up\10climb up\10climb up\10climb up %;\
    /goto mark kill %;\
    /repeat -1 1 /FF_Report %;\
    /return %;\
  /else \
    /set FF_en=0 %;\
    /return %;\
  /endif %;\
  /gl %;peer

/vdef -mregexp -t'^[> ]*You peer around the area\.$' FF_Checked = \
  /if (FF_en) \
    /set FF_en=$[FF_en+1] %;\
    /FF_Search %;\
  /endif

/vdef -mregexp -t'^[> ]*Allycis\.$' FF_SawFish = \
  /if (FF_en == 1) /set FF_found=dive %;\
  /elseif (FF_en == 2) /set FF_found=w %;\
  /elseif (FF_en == 3) /set FF_found=w sw %;\
  /elseif (FF_en == 4) /set FF_found=sw %;\
  /elseif (FF_en == 5) /set FF_found=sw s %;\
  /elseif (FF_en == 6) /set FF_found=sw 2 s %;\
  /elseif (FF_en == 7) /set FF_found=sw s se %;\
  /elseif (FF_en == 8) /set FF_found=e s sw %;\
  /elseif (FF_en == 9) /set FF_found=e 2 s %;\
  /elseif (FF_en == 10) /set FF_found=e s %;\
  /elseif (FF_en == 11) /set FF_found=e %;\
  /elseif (FF_en == 12) /set FF_found=dive %;\
  /else /set FF_found=0 %;\
  /endif

/vdef -mregexp -t'^[> ]*Allycis moving silently\.$' FF_SawFish2 = /FF_SawFish
/vdef -mregexp -t'^[> ]*A dark room\.$' FF_NoLight = \
  /set FF_needlight=1

/undef vdef
