/set MM 1 
/def -i MM = \
     /if (MM) \
        /set MM 0 %;\
        /echo -aB * Mage macros off. %;\
     /else \
        /set MM 1 %;\
        /echo -aB * Mage macros on. %;\
     /endif
/set Group 0
/def -i Group = \
     /if (Group) \
        /set Group 0 %;\
        /echo -aB * Group casts off. %;\
     /else \
        /set Group 1 %;\
        /echo -aB * Group casts on. %;\
     /endif

/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> armor *(general|slashing|crushing|thrusting|)$' mageArmor = \
    /let aT=%P2 %;\
    /if /test aT =~ ""%; /then \
      /let aT=general %;\
    /endif %;\
    /if (MM) \
      /uGag %{doGlance} %;\
      /if (Group) \
        group armor %{aT} %;\
      /else \
        armor %{aT} on %P1 %;\
      /endif %;\
    /endif

/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> aegis *(general|ice|fire|acid|magic|energy|electricity|sound|)$' mageAegis = \
    /let aT=%P2 %;\
    /if /test aT =~ ""%; /then \
      /let aT=general %;\
    /endif %;\
    /if (MM) \
      /uGag %{doGlance} %;\
      /if (Group) \
        group aegis %{aT} %;\
      /else \
        aegis %{aT} on %P1 %;\
      /endif %;\
    /endif

/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> shield *(general|ice|fire|acid|magic|energy|electricity|)$' mageShield = \
    /let aT=%P2 %;\
    /if /test aT =~ ""%; /then \
      /let aT=general %;\
    /endif %;\
    /if (MM) \
      /uGag %{doGlance} %;\
      keep all %;\
      shield %{aT} %;\
      give all to %P1 %;\
    /endif

/def -i -mregexp -t'^[> ]*<< ([a-zA-Z]*) >> scare ([a-zA-Z0-9 ]*)$' mageScare = \
     /if (MM) \
       /uGag %{doGlance} %;\
       scare %P2 %;\
     /endif

/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> acumen$' mageAcumen = \
    /if (MM) \
      /uGag %{doGlance} %;\
      acumen %P1 %;\
    /endif

/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> aura$' mageAura = \
    /if (MM) \
      /uGag %{doGlance} %;\
      /if (Group) \
        group aura %;\
      /else \
        aura %P1 %;\
      /endif %;\
    /endif

/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> blur$' mageBlur = \
    /if (MM) \
      /uGag %{doGlance} %;\
      /if (Group) \
        group blur %;\
      /else \
        blur %P1 %;\
      /endif %;\
    /endif

/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> featherfall$' mageFeatherFall = \
    /if (MM) \
      /uGag %{doGlance} %;\
      /if (Group) \
        group featherfall %;\
      /else \
        featherfall %P1 %;\
      /endif %;\
    /endif

/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> light$' mageWerelight = \
    /if (MM) \
      /uGag %{doGlance} %;\
      /if (Group) \
        group werelight %;\
      /else \
        werelight %;\
        extinguish werelight %;\
        give werelight to %P1 %;\
      /endif %;\
    /endif

/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> getme$' mageSummon = \
    /if (MM) \
      summon %P1 %;\
    /endif

/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> comehere$' mageTP = \
    /if (MM & !IC) \
      teleport %P1 %;\
    /endif

/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> stoneskin$' mageStoneskin1 = \
    /if (MM) \
      /uGag %{doGlance} %;\
      stoneskin %P1 50 %;\
    /endif
/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> gstoneskin$' mageGStoneskin1 = \
    /if (MM) \
      /uGag %{doGlance} %;\
      group stoneskin 50 %;\
    /endif
/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> stoneskin ([0-9]+)$' mageStoneskin2 = \
    /if (MM) \
      /uGag %{doGlance} %;\
      stoneskin %P1 %P2 %;\
    /endif
/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> gstoneskin ([0-9]+)$' mageGStoneskin2 = \
    /if (MM) \
      /uGag %{doGlance} %;\
      group stoneskin %P2 %;\
    /endif

/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> invis$' mageInvis = \
    /if (MM) \
      /test invForced := invForced + 1 %;\
      /uGag %{doGlance} %;\
      /if (!IC) remove collar %;/endif %;\
      invis %P1 %;\
      /if (!IC) wear collar %;/endif %;\
    /endif
/def -p1 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> ginvis$' mageGInvis = \
    /if (MM) \
      /test invForced := invForced + 1 %;\
      /uGag %{doGlance} %;\
      /if (!IC) remove collar %;/endif %;\
      group invis %;\
      /if (!IC) wear collar %;/endif %;\
    /endif
