/echo -aB ## Maps loaded.  (not all done!)
/echo -aB ## Type "/maps" to look up maps.

/def -i echomap = /quote -0 /echo -aB * '%*

/def -i maps = \
  /if ({#} > 0) \
    /eval /map_%{1} %;\
  /else \
        /echo -aB Maps %;\
        /echo The following maps are available: %;\
        /echo %;\
        /echo -aCgreen n : Path north of Farcaern %;\
        /echo -aCgreen e : Path east of Farcaern %;\
        /echo -aCgreen s : Path south of Farcaern %;\
        /echo -aCgreen w : Path west of Farcearn %;\
        /echo -aBCcyan |city| %;\
        /echo -aBCcyan |north|  |east|  |south|  |west| %;\
        /echo %;\
        /echo Todo: %;\
        /echo Ancient Burial Mound, River part of ice caves %;\
        /echo Fighter/Thief/Mage Guilds, Ruined Keep?, Newbie Stream %;\
        /echo Lemme know what else! %;\
        /echo %;\
        /echo Expand listings denoted by |loc| by typing /maps loc %;\
        /echo e.g. /maps north to see maps of areas north of Farcaern %;\
  /endif

/def -i map_n = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/North.txt"
/def -i map_e = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/East.txt"
/def -i map_s = /echomap "~/desktop/odcode/tf/tfstuff/maps/South/South.txt"
/def -i map_w = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/West.txt"

/def -i map_city = \
        /echo -aB Farcaern Maps %;\
        /echo -aCgreen farcaern : General Map of Farcaern (from City Hall) %;\
        /echo -aCgreen fighter  : Fighter Quarter (from City Hall) %;\
        /echo -aCgreen mage     : Mage Quarter (from City Hall) %;\
        /echo -aCgreen priest   : Priest Quarter (from City Hall) %;\
        /echo -aCgreen thief    : Thief Quarter (from City Hall) %;\
        /echo -aCgreen priestg  : Priest Guild %;\
        /echo -aCgreen sewer    : Farcaern Sewers %;\
        /echo -aCgreen temple   : Ancient Temple in the Sewers %;\

/def -i map_farcaern = /echomap "~/desktop/odcode/tf/tfstuff/maps/Farcaern/Farcaern.txt"
/def -i map_fighter = /echomap "~/desktop/odcode/tf/tfstuff/maps/Farcaern/Fighter\ Quarter.txt"
/def -i map_mage = /echomap "~/desktop/odcode/tf/tfstuff/maps/Farcaern/Mage\ Quarter.txt"
/def -i map_priest = /echomap "~/desktop/odcode/tf/tfstuff/maps/Farcaern/Priest\ Quarter.txt"
/def -i map_priestg = /echomap "~/desktop/odcode/tf/tfstuff/maps/Farcaern/Priest\ Guild.txt"
/def -i map_thief = /echomap "~/desktop/odcode/tf/tfstuff/maps/Farcaern/Thief\ Quarter.txt"
/def -i map_sewers = /echomap "~/desktop/odcode/tf/tfstuff/maps/Farcaern/Sewers.txt"
/def -i map_temple = /echomap "~/desktop/odcode/tf/tfstuff/maps/Farcaern/Temple.txt"

/def -i map_north = \
        /echo -aB Maps of the north %;\
        /echo -aCgreen abyss   : Abyss %;\
        /echo -aCgreen bandu   : Bandu Forest and Village %;\
        /echo -aCgreen black   : Black Tower %;\
        /echo -aCgreen bug     : Bug Lair %;\
        /echo -aCgreen elf     : Elf Forest %;\
        /echo -aCgreen arch    : Elven Archery School %;\
        /echo -aCgreen goblin  : Goblin Cave %;\
        /echo -aCgreen icec    : Ice Caves %;\
        /echo -aCgreen icep    : Ice Plains %;\
        /echo -aCgreen kortal  : Kortal Forest (Newbie Realm) %;\
        /echo -aCgreen fort    : Kren Fortress %;\
        /echo -aCgreen kren    : Kren Village %;\
        /echo -aCgreen lasfort : Lasarian's Fortress %;\
        /echo -aCgreen maze    : Maze of Death %;\
        /echo -aCgreen nwplain : Northwest Plains %;\
        /echo -aCgreen red     : Red Tower %;\
        /echo -aCgreen secor   : General Secor's House %;\
        /echo -aCgreen viking  : Viking Town %;\
        /echo -aCgreen windy   : Windy Plains

/def -i map_abyss = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Abyss.txt"
/def -i map_bandu = \
  /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Bandu\ Forest\ and\ Village.txt"
/def -i map_black = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Black\ Tower.txt"
/def -i map_bug = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Bug\ Lair.txt"
/def -i map_elf = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Elf\ Forest.txt"
/def -i map_arch = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Elven\ Archery\ School.txt"
/def -i map_goblin = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Goblin.txt"
/def -i map_icec = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Ice\ Caves.txt"
/def -i map_icep = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Ice\ Plains.txt"
/def -i map_kortal = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Kortal.txt"
/def -i map_fort = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Kren\ Fortress.txt"
/def -i map_kren = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Kren\ Village.txt"
/def -i map_lasfort = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Lasarian's\ Fortress.txt"
/def -i map_maze = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Maze.txt"
/def -i map_nwplain = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Northwest\ Plains.txt"
/def -i map_red = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Red\ Tower.txt"
/def -i map_secor = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Secor.txt"
/def -i map_viking = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Viking\ Town.txt"
/def -i map_windy = /echomap "~/desktop/odcode/tf/tfstuff/maps/North/Windy\ Plains.txt"

/def -i map_east = \
        /echo -aB Maps of the east %;\
        /echo -aCgreen alesia   : Town of Alesia %;\
        /echo -aCgreen lake     : Alesian Lake %;\
        /echo -aCgreen dforest  : Dark Forest %;\
        /echo -aCgreen druegar  : Druegar Camp %;\
        /echo -aCgreen fair     : Traveling Fair %;\
        /echo -aCgreen fogc     : Fog Caves %;\
        /echo -aCgreen fog      : Fog Forest %;\
        /echo -aCgreen grassy   : Grassy Plains %;\
        /echo -aCgreen kibo     : Kibo Village %;\
        /echo -aCgreen lava     : Lava Caves %;\
        /echo -aCgreen maldicee : Village of Maldicee and Port Somias %;\
				/echo -aCgreen marsh    : Inland Marsh %;\
        /echo -aCgreen funhouse : Madam Foo's Funhouse %;\
        /echo -aCgreen midian   : Midian Forest %;\
        /echo -aCgreen vale     : Misty Vale %;\
        /echo -aCgreen operatus : Village of Operatus %;\
        /echo -aCgreen park     : Sir Flarden's Park %;\
        /echo -aCgreen pond     : Newbie Pond %;\
        /echo -aCgreen pyr      : Pyramid %;\
        /echo -aCgreen tomb     : King Earland's Tomb

/def -i map_alesia = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Alesia.txt"
/def -i map_lake = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Alesian\ Lake.txt"
/def -i map_dforest = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Dark\ Forest.txt"
/def -i map_druegar = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Druegar\ Camp.txt"
/def -i map_fair = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Fair.txt"
/def -i map_fogc = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Fog\ Caves.txt"
/def -i map_fog = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Fog\ Forest.txt"
/def -i map_grassy = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Grassy\ Plains.txt"
/def -i map_kibo = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Kibo.txt"
/def -i map_lava = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Lava\ Caves.txt"
/def -i map_maldicee = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Maldicee.txt"
/def -i map_marsh = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Marsh.txt"
/def -i map_funhouse = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Funhouse.txt"
/def -i map_midian = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Midian\ Forest.txt"
/def -i map_vale = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Misty\ Vale.txt"
/def -i map_operatus = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Operatus.txt"
/def -i map_park = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Park.txt"
/def -i map_pond = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Pond.txt"
/def -i map_pyr = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Pyramid.txt"
/def -i map_tomb = /echomap "~/desktop/odcode/tf/tfstuff/maps/East/Tomb.txt"

/def -i map_south = \
        /echo -aB Maps of the south %;\
        /echo -aCgreen alk     : Alkaizel Camp %;\
        /echo -aCgreen hope    : Coastal Caverns %;\
        /echo -aCgreen girbali : Fallow Plains of Girbali %;\
        /echo -aCgreen ordenk  : Village of Ordenk and Slar Swamps %;\
        /echo -aCgreen liz     : Ruined Temple (Lizardman Stronghold) %;\
        /echo -aCgreen trais   : City of Traispek

/def -i map_alk = /echomap "~/desktop/odcode/tf/tfstuff/maps/South/Alkaizel.txt"
/def -i map_hope = /echomap "~/desktop/odcode/tf/tfstuff/maps/South/Coastal\ Caverns.txt"
/def -i map_girbali = /echomap "~/desktop/odcode/tf/tfstuff/maps/South/Girbali.txt"
/def -i map_ordenk = /echomap "~/desktop/odcode/tf/tfstuff/maps/South/Ordenk.txt"
/def -i map_liz = /echomap "~/desktop/odcode/tf/tfstuff/maps/South/Ruined\ Temple.txt"
/def -i map_trais = /echomap "~/desktop/odcode/tf/tfstuff/maps/South/Traispek.txt"

/def -i map_west = \
        /echo -aB Maps of the west %;\
        /echo -aCgreen angus     : Northwest Mines (Angus) %;\
        /echo -aCgreen troll     : Castle of Trolls %;\
        /echo -aCgreen convent   : Abandoned Convent %;\
        /echo -aCgreen grym      : Frigdin Valley (Grymwald Forest) %;\
        /echo -aCgreen gutmar    : Town of Gutmar %;\
        /echo -aCgreen irons     : Dwarven Kingdom of Ironspike %;\
        /echo -aCgreen lime      : Limestone Temple %;\
        /echo -aCgreen mines     : Ironspike Mines %;\
        /echo -aCgreen ngarden   : Newbie Garden %;\
        /echo -aCgreen nmountain : Newbie Mountain %;\
        /echo -aCgreen nstream   : Newbie Stream (incomplete) %;\
        /echo -aCgreen bog       : Northwest Caverns %;\
        /echo -aCgreen plateau   : Rugged Plateau %;\
        /echo -aCgreen crypt     : Crypts of Tempus %;\
        /echo -aCgreen tomak     : Village of Tomak %;\
        /echo -aCgreen creaver   : Creaver Pyramid

/def -i map_angus = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Angus.txt"
/def -i map_troll = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Castle.txt"
/def -i map_convent = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Convent.txt"
/def -i map_grym = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Frigdin\ Valley.txt"
/def -i map_gutmar = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Gutmar.txt"
/def -i map_irons = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Ironspike.txt"
/def -i map_lime = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Limestone\ Temple.txt"
/def -i map_mines = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Mines.txt"
/def -i map_ngarden = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Newbie\ Garden.txt"
/def -i map_nmountain = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Newbie\ Mountain.txt"
/def -i map_nstream = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Newbie\ Stream.txt"
/def -i map_bog = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Northwest\ Caverns.txt"
/def -i map_plateau = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Plateau.txt"
/def -i map_crypt = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Tempus.txt"
/def -i map_tomak = /echomap "~/desktop/odcode/tf/tfstuff/maps/West/Tomak.txt"
/def -i map_creaver = /echomap "~/desktop/odcode/tf/tfstuff/maps/west/Creaver.txt"
