;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; OD STUFF
;/def -i 1 = /world od
;/def -i 2 = /world od2

/set exContainer=chest 2
/set hidePlace=tormal
/set eqPlace=tormal
/set fpWeapon=spear
/set Multiple=3/1

/set TFPATH=~/desktop/odcode/tf/tfstuff /r4/tfstuff %{TFLIBDIR}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;  Trigs to protect weenies from setting off trigs
;;;;   and to make tells/shouts/says go trough gags

/def -i -p999 -t'* shouts:*' ignore_shout = 
/def -i -p999 -t'* tells you:*' ignore_tell = 
/def -i -p999 -t'Llardin answers * prayer and*' ignore_ppose = 
/def -i -p999 -t'From * hiding place in the shadows, *' ignore_tpose = 
/def -i -p999 -t'*s triumphant battle cry * echoes throughout the land.' ignore_fpose =
/def -i -p999 -ag -mregexp -t'You let off a howling yell: (.*)' change_fpose = /echo -aCyellow Your trimphant battle cry: '%P1' echoes throughout the land.
/def -i -p999 -t'*explodes * in the sky.' ignore_mpose =

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;  Disarm Trig

/def -i -mregexp -t'^[> ]*You scream in horror as your (.*) falls to the ground.' disarm_1 = \
  /let x=$[tolower({P1})] %;get %x\10wield %x\10keep %x

/def -i -mregexp -t'^[> ]*You are startled with fear and drop the ([^!]*)!$' BeastRoar = \
  /let x=$[tolower({P1})] %;get %x\10wield %x\10keep %x

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; TP Amulet Trigs

/def -i -t'*The amulet?s amethyst flickers a sickly green*' again_amulet = g
/def -i -h'SEND say[m|h|v]*' ShopAmuletHook = /eval remove necklace\10wear %{ShopAmulet}\10%*
/def -i -t'*azure light blooms deep within*' AmuletSuccess = /eval remove %{ShopAmulet}\10wear necklace
/def -i setamulet = /set ShopAmulet %*

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;  Sigil Trigs

/def -i -p1000 -t'*Your*acolyte tells you*ready*' extend_priest = extend
/def -i -p1000 -t'* as though it is ready to return.' extend_mage = extend
/def -i -p1000 -t'*The urchin tells you:  Time?s just about up, ?uv.' extend_thief = extend
/def -i -p1000 -t'*Your squire tells you:  If you are done with*I shall return.' extend_fighter = extend
/def -i -t'Your deeppocket will expire in approximately one minute...' extend_pocket = deeppocket 50

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;  Snowball Trigs

/set Snow 1 
/def -i Snow = \
     /if (Snow == 0) \
        /set Snow 1 %;\
        /echo -aB * Automatic Catch. %;\
     /elseif (Snow == 1) \
        /set Snow 2 %;\
        /echo -aB * Dodge 'em! %;\
     /elseif (Snow == 2) \
        /set Snow 0 %;\
        /echo -aB * Manual Catch. %;\
     /endif

/def -i -p1 -t'*threw a snowball at you!  Better duck!' cs = \
  /if (Snow == 1) catch snowball %; /elseif (Snow == 2) duck %;/endif
/def -i -p1 -t'*caught the snowball and threw it back!*Better duck!' cs2 = \
  /if (Snow == 1) catch snowball %; /elseif (Snow == 2) duck %;/endif

/set snow_count 0

/def -i -mregexp -F -t'^[> ]*You vigorously shake all of the snow off of yourself.$' snow_Cnt = \
  /if (snow_count) \
    /set snow_num $[snow_num + 1] %;\
    /send \\shake %;\
  /endif

/def -i -mregexp -F -t'^[> ]*You shake your head.$' snow_End = \
  /if (snow_count) \
    /if (snow_num > 0) \
      /echo -aB * Total Hits Taken:  %snow_num %;\
    /endif %;\
    /set snow_count 0 %;\
  /endif

/def -i snowc = \
  /set snow_count 1 %;\
  /set snow_num 0 %;\
  /send \\shake

;/def -i -p9999 -mregexp -t'[> ]*The snowball hits ([A-Z][a-z]*) in the face!$' snow_Laugh = \
;  point %P1 %;\
;  laugh

;/def -i -mregexp -F -h'SEND ^\\shake$' snow_hook = /snowc

/def -i gsb = /for i 1 6 make snowball\10put all in %{exContainer}
/def -i getsnow = /eval /goto drift1 %%;/gsb %%;/goto drift2 %%;/gsb %%;/goto drift3 %%;/gsb %%;/goto %{mpCurLoc}
/def -i sb = /eval get snowball from %{exContainer} %;toss snowball at %{1}

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Stash Spot

/def -i setHide = /set hidePlace %*
;/def -i setHide = /if /test {#} > 0 %;\
;                    /then /set hidePlace %{*}%;\
;                  /endif %;/set hidePlace
/def -i don = follow ditch all %;/at %{hidePlace} get %{1-5000} coins %;/at booth donate %{1-5000} coins
/def -i newfetish = follow ditch all %;/at %{hidePlace} get fetish %;keep fetish %;/at macs sell fetish 2
/def -i s = follow ditch all %;/at %{hidePlace} %*
/def -i drop = follow ditch all %;/at %{hidePlace} drop %*
/def -i get = follow ditch all %;/at %{hidePlace} get %*
/def -i s1 = follow ditch all %;/at %{hidePlace} get chest\10put shoe in chest\10drop chest
/def -i s2 = follow ditch all %;/at %{hidePlace} get bag\10put shoe in bag\10drop bag\10get chest\10put shoe in chest\10drop chest
/def -i s3 = follow ditch all %;/at %{hidePlace} drop shoe\10get bag\10put shoe in bag\10drop bag\10get chest\10put shoe in chest\10drop chest

;/def -p1 -mregexp -t'^[> ]*You feel that your lucky streak has run out.*' RubFetish = /if /test fetr %;/then /eval rub fetish %;/endif
;/def -p1 -mregexp -t'^[> ]*You rub the fetish but nothing special happens.*' FetishOut = /if /test fetc %;/then /eval /newfetish %;/eval rub fetish %;/endif

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;  Inout Macros

/def -i Fish = dive\10l\10l\10l\10l\10x\10!w\10l\10l\10l\10l\10x\10!sw\10l\10l\10l\10l\10x\10!e\10l\10l\10l\10l\10x\10!s\10l\10l\10l\10l\10x\10!s\10l\10l\10l\10l\10x\10!e\10l\10l\10l\10l\10x\10!n\10l\10l\10l\10l\10x\10so\10!e\10l\10l\10l\10l\10x\10so\10!n\10l\10l\10l\10l\10x\10!n\10l\10l\10l\10l\10x\10!w\10!climb up\10!climb up\10!climb up\10!climb up\10!climb up\10!climb up
/def -i Gruesly = s\10x\10sw\10x\10e\10x\10e\10x\10nw\10n
/def -i Starn = n\10n\10n\10x\10s\10x\10open flap\10s\10x\10s
/def -i Slar = d\10n\10x\10n\10x\10se\10x\10sw\10x\10u

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;  Random Stuff

/set doGlance=glance\10glance\10glance\10glance\10glance\10glance\10glance\10glance\10glance\10glance\10glance\10glance\10glance\10glance\10glance
/def -i gl = /ugag %{doGlance} %;glance

;/def -i -mregexp -h'SEND l$' GlanceHook = /eval /echo hi %;/ugag %{doGlance} %;/send %*

/set IC 0
/def -i IC = \
     /if (IC) \
        /set IC 0 %;\
        /echo -aB * InCombat status off. %;\
     /else \
        /set IC 1 %;\
        /echo -aB * InCombat status on. %;\
     /endif

/set Bot 0
/def -i Bot = \
     /if (Bot) \
        /set Bot 0 %;\
        /echo -aB * Bot macros off. %;\
     /else \
        /set Bot 1 %;\
        /echo -aB * Bot macros on. %;\
     /endif

/set Hp 0 
/def -i Hp = \
     /if (Hp) \
        /set Hp 0 %;\
        set hpdisplay 1 %;\
     /else \
        /set Hp 1 %;\
        set hpdisplay on %;\
     /endif

/set Swim 0
/def -i Swim = \
     /if (Swim) \
        /set Swim 0 %;\
        alias n north %;\
        alias s south %;\
        alias w west %;\
        alias e east %;\
        alias nw northwest %;\
        alias ne northeast %;\
        alias sw southwest %;\
        alias se southeast %;\
        /echo -aB * Swim aliases off. %;\
     /else \
        /set Swim 1 %;\
        alias n swim north %;\
        alias s swim south %;\
        alias w swim west %;\
        alias e swim east %;\
        alias nw swim northwest %;\
        alias ne swim northeast %;\
        alias sw swim southwest %;\
        alias se swim southeast %;\
        /echo -aB * Swim aliases on. %;\
     /endif

/def -i train = /at %{1} say train me\%;say %{2}\%;say yes
/def -i sbracers = w\10open chest\10get all from chest\10e
/def -i getscroll = jump on slab\10get scroll\10w
/def -i doring = open closet\10get broom\10sweep\10search hearth
/def -i d = get flask from %{exContainer}\10drink flask

/def -i doFr = get torch\10light torch\10heat slab with torch\10douse torch\10drop torch\10get rubble\10n\10get pouch\10s

/def -i getmask = get ring\10remove ring 2\10remove ring 3\10wear ring\10climb ladder\10put ring in pattern\10get mask\10climb ladder\10drop ring\10wear ring\10wear ring 2

/def -i GetRaven = /g nwworm %;get worm %;/g raven %; give worm to raven %;/c
/def -i GetOgre = /g rope %;buy rope %;/g shaft %;tie rope to hook %;/g ogre
/def -i GetLocket = /g rope %;buy rope %;/g shaft %;tie rope to hook %;/g fiend

/def -i ex = get %* from %{exContainer} %;put %* 2 in %{exContainer}%;keep %*%;wear %*

/def -i ea = /ex amulet
/def -i eh = /ex helmet
/def -i eb = /ex bracers
/def -i eg = /ex gloves
/def -i ec = /ex cloak

/def -i slist = \
  /while ({#} > 0) \
    /sone %{1} %;\
    /shift %;\
  /done
/def -i sone = get %{*} %;drop %{*} 2 %;wear %{*} %;keep %{*}

/def -i barn = get cloak\10remove cloak 2\10wear cloak\10crawl hole\10open door\10open door 2\10s\10e\10n\10drop cloak\10wear cloak\10s\10w\10n

/def -i sober = /at con buy espresso

;/def -i buyheal = /at Drinks /for i 1 %{1-1} buy manischewitz\10cask\10put cask in %{exContainer}

;/def -i heal = get cask from %{exContainer}\10guzzle cask\10recycle cask

/def -i scry = remove helmet 2\10wear helmet\10picture %*\10remove helmet\10wear helmet 2

/def -i fw = follow ditch %* %;follow %*

/def -i show = /list -i -- ->%1 
/def -i area = /list -i = ->%1 *

/def -i idle = /repeat -120 1000 /send

/def -i OD = /def -i -p999 -h'CONFAIL' tmpOD = /repeat -1 1 /world %1 

;/def -i -p1 -ag -t'*not quite enough*' gagfountain =

/def -i getdef = /eval /goto gutmar%%;e\10n\10w\10pray\10e\10s\10w%%;/goto %{mpCurLoc}

/def -i pet = remove ring 3%;wear stone ring%;/for i 1 5 petrify %*%;remove stone ring%;wear ring 3

/def -i twist = get ring from %{exContainer}\10remove ring 3\10wear ring\10twist ring\10put ring in %{exContainer}\10wear ring 2

/def -i gagfix = /ugagoff%;/for i 1 20 /let a=$(/uagetq)%;/echo -aB * Gagging Fixed.

/set kWhere 1
/def -i haze = \
                /eval /set kWhere=$[kWhere+1] %;\
                /if /test kWhere > 5 %;\
                /then /set kWhere=1 %;\
                /endif %;\
                /eval /goto haze%{kWhere} %;\
                %{ioMove} haze

/def -i Ropetrick = /test Ropetrick := !Ropetrick %;\
  /echo -aB * Ropetrick Macros: %{Ropetrick}
/def -iF -mregexp -t'^[> ]*[a-zA-Z]* incants strangely and ties a rope' \
  ClimbRopeTrick = \
  /if (Ropetrick) climb rope\10climb rope\10climb rope %;/endif

/def -i bl = /at meat buy side of lamm %;keep side
/def -i bc = /at drinks buy cask of manischewitz %;keep cask
/def -i devour = get side from %exContainer\10devour side\10put side in %exContainer
/def -i guzzle = get cask from %exContainer\10guzzle cask\10put cask in %exContainer

/def -i -ahCwhite -t'*hand high and calls upon Llardin\'s darkness....' TapAttack =

/def -i -ahCwhite -t'*You have been summoned by Methrin!' MethSummon =

/def -i -ahCwhite -mregexp -t'^[> ]*([A-Za-z]*) found something.?' SkeleFound =

/def -i -aB -mregexp -t'^[> ]*A steel hatchling died\.$' BeastHatch =

/def -i -mregexp -t'^[> ]*The black stone door is closed\.$' RochDoor1 = open stone door
/def -i -mregexp -t'^[> ]*You pull and pull on the black stone door' RochDoor2 = open stone door
/def -i -mregexp -t'^[> ]*The back door is closed\.$' RochDoor3 = open back door
/def -i -mregexp -t'^[> ]*You pull and pull on the wooden door' RochDoor4 = open wooden door
/def -i -mregexp -t'^[> ]*The wooden door is closed\.$' RochDoor5 = open wooden door
/def -i -mregexp -t'^[> ]*You are too weak to open the wood door\.$' RochDoor6 = open wooden door

/def -i -mregexp -t'^[> ]*You trip over the clutter and are able to right yourself quickly!' ThomasExit = west

;/def -i -mregexp -t'^[> ]*You try to run, but your feet are held fast by the spider\'s sticky web!$' LicorisExit = south

;Unfortunately, you trip over an untied bootstrap and land flat on your face, 
;more entangled in the web than ever.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;  Allycis related stuff

/def -i -ag -t'*pink and red ring glows a bright *, and you feel your purse*' RingCoins = 
/def -i -ah -t'*pink and red ring glows a bright * and drops from *' RingDrop = get ring\10keep ring

/set crabCount=0
/def -i -Fp999 -mregexp -t'^[> ]*A small crab appears out of grey smoke and attaches itself to you!$' anotherCrab = /test crabCount := crabCount + 1

/def -i -Fp999 -mregexp -t'^[> ]*You manage to make the crab lose its grip, and it disappears.*' crabGone = /test crabCount := crabCount - 1

/def -i -Fp999 -mregexp -t'^[> ]*With every labored heartbeat, water seeps into your lungs.$' needwb = party wb
/def -i -Fp999 -mregexp -t'^[> ]*Your lungs scream in pain as your air supply lessens.$' needwb2 = party wb
/def -i -Fp999 -mregexp -t'^[> ]*Your vision dims as your air nearly runs out.$' needwb3 = party wb
/def -i -Fp999 -mregexp -t'^[> ]*Your lungs tighten in protest at the lack of air.$' needwb4 = party wb
/def -i -Fp999 -mregexp -t'^[> ]*You feel the water-breathing wear off.$' needwb5 = /if /test wb %;/then party wb %;/endif 

;Despite your best efforts, you're about to scream for air.
;You begin to pass out from lack of air.
;Your sight dims and stars swim before you.
;With every labored heartbeat, water seeps into your lungs.

/def -i -Fp999 -mregexp -t'^[> ]*You try to climb up the wall' ExitLake = climb wall

/def -i clearCrabs = /set crabCount=0

/load tfstuff/loot.tf
/load tfstuff/acurion.tf
/load tfstuff/obs.tf
/load tfstuff/encscroll.tf
/load tfstuff/locfish.tf
/load tfstuff/gen_io.tf
/load tfstuff/thiefhunt.tf
/load tfstuff/Hroom.tf
/load tfstuff/bot.tf
;/load tfstuff/babytalk.tf
/load tfstuff/flist.tf
/load tfstuff/mvp.tf
/load tfstuff/skymark.tf
/load tfstuff/gates.tf
;/load tfstuff/death.tf
/load tfstuff/dummy.tf
/load tfstuff/status.tf
/load tfstuff/mplist.tf
/load tfstuff/quests.tf
/load tfstuff/maps.tf
/load tfstuff/log.tf

/def -i mefighter  = /load tfstuff/fighter/myfighter.tf %;\
                     /load ~/tfstuff/fighter.tf
/def -i mefighter2 = /mefighter %;/load tfstuff/fighter/myfighter2.tf %;\
                     /load ~/tfstuff/fighter.tf
/def -i bowfighter = /load tfstuff/fighter/myfighter.tf %;\
                     /load ~/tfstuff/fighter.tf
/def -i dgfighter  = /mefighter %;/load tfstuff/fighter/myfighter2.tf %;\
                     /load ~/tfstuff/fighter.tf
/def -i mepriest   = /load tfstuff/priest/mypriest.tf %;\
                     /load ~/tfstuff/priest.tf
/def -i memage     = /load tfstuff/mage/mymage.tf %;\
                     /load ~/tfstuff/mage.tf
/def -i methief    = /load tfstuff/thief/thiefrc.tf %;\
                     /load ~/tfstuff/thief.tf
/def -I menecro    = /load tfstuff/necromancers/mynecro.tf %;\
                     /load ~/tfstuff/necro.tf 


/echo -aB ##
/echo -aB ## To load class specific macros:
/echo -aB ##  /bowfighter  : Fighter (Bow)
/echo -aB ##  /dgfighter   : Fighter (Demon Weapon), /setweap <yourweapontype>
/echo -aB ##  /mepriest    : Priest
/echo -aB ##  /memage      : Mage
/echo -aB ##  /methief     : Thief
/echo -aB ##  /menecro     : Necromancer

/mpgag on
/where cath
