/loaded mage.tf

;; For setting different armor and aegis types on tank vs everyone else
/set TankAegisType general
/set OtherAegisType general
/set TankArmorType general
/set OtherArmorType general

/set MageWeapon sphaera

;; For collecting rings of luck from operatus
;; /registerlistener mobDied getring
/def getring = /if (world_info() =~ 'Mage') get ring\10get ring from corpse\10put all in pocket%; /endif

/def -i MageAction = \
	/if (inCombat) \
		/if (!TankBlur | !MageBlur | !HealerBlur | !ThugBlur) group blur%; \
		/elseif (!TankAegis) aegis %TankAegisType on %TankName%; \
		/elseif (!HealerAegis | !MageAegis | !ThugAegis) group aegis %OtherAegisType%; \
		/elseif (!TankArmor) armor %TankArmorType on %TankName%; \
		/elseif (!HealerArmor | !MageArmor | !ThugArmor) group armor %OtherArmorType%; \
		/elseif (!TankStoneskin) stoneskin %TankName $[TankMaxHp / 5]%; \
		/elseif (!MageStoneskin) stoneskin $[MageMaxHp / 4]%; \
		/elseif (!MageCorona) corona $[MageMaxHp / 4]%; \
		/elseif (!HealerStoneskin) stoneskin %HealerName $[HealerMaxHp / 4]%; \
		/elseif (!ThugStoneskin) stoneskin %ThugName $[ThugMaxHp / 4]%; \
		/else %mageSpell%; \
		/endif%; \
	/elseif (regrouping) \
		/if (!MageIsHere) teleport %ThugName%; \
		/elseif (!HealerIsHere) \
			summon %HealerName%; \
		/elseif (!TankIsHere) \
			summon %TankName%; \
		/elseif (!HealerFollowing | !MageFollowing | !TankFollowing) \
			/followAll%; \
		/else /set regrouping 0%; \
		/endif%; \
	/elseif (MageIntoxLevel < 4) \
		/if (!MageStoneskin) stoneskin $[MageMaxHp / 4]%; \
		/elseif (!MageCorona) corona $[MageMaxHp / 4]%; \
		/elseif (!HealerStoneskin) stoneskin %HealerName $[HealerMaxHp / 4]%; \
		/elseif (!ThugStoneskin) stoneskin %ThugName $[ThugMaxHp / 4]%; \
		/elseif (!TankBlur | !MageBlur | !HealerBlur | !ThugBlur) group blur%; \
		/elseif (!TankArmor) armor %TankArmorType on %TankName%; \
		/elseif (!HealerArmor | !MageArmor | !ThugArmor) group armor %OtherArmorType%; \
		/elseif (!TankAegis) aegis %TankAegisType on %TankName%; \
		/elseif (!HealerAegis | !MageAegis | !ThugAegis) group aegis %OtherAegisType%; \
		/elseif (!TankStoneskin) stoneskin %TankName $[TankMaxHp / 4]%; \
		/endif%; \
	/endif

