;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; PartyPriest.tf - Priest Utility Trigs
;;;      by F
;;;
;;; See END OF FILE for default tank list

/set PM 1 
/def -i PM = \
     /if (PM) \
        /set PM 0 %;\
        /echo -aB * Priest macros off. %;\
     /else \
        /set PM 1 %;\
        /echo -aB * Priest macros on. %;\
     /endif

/set Restrict 0
/def -i PMRestrict = \
     /if (Restrict) \
        /set Restrict 0 %;\
        /echo -aB * Restricted use off. %;\
     /else \
        /set Restrict 1 %;\
        /echo -aB * Restricted use on. %;\
     /endif

/set Flock 0 
/def -i Flock = \
     /if (Flock) \
        /set Flock 0 %;\
        /echo -aB * Flock cure off. %;\
     /else \
        /set Flock 1 %;\
        /echo -aB * Flock cure on. %;\
     /endif

/set HealSelf=1
/def -i HealSelf = \
     /if (HealSelf) \
        /set HealSelf 0 %;\
        /echo -aB * HealSelf off. %;\
     /else \
        /set HealSelf 1 %;\
        /echo -aB * HealSelf on. %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> heal$' tpHeal = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       cure %P1 %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> fheal$' tpfHeal = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       flock cure %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> bless$' tpfBless = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       bless all %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> wb$' tpWB = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       waterbreath %P1 %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> cleanse$' tpCleanse = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       cleanse %P1 %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> fcleanse$' tpFCleanse = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       flock cleanse %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> barkskin$' tpBarkskin = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       barkskin %P1 %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> cleanse ([a-zA-Z0-9 ]*)' tpCleanseM = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       cleanse %P2 %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> light$' tpLight = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       illuminate\10give orb to %P1 %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> fwb$' tpfWB = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       flock waterbreath %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> boozle$' tpBooze = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       boozle %P1 %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> boozle ([a-zA-Z0-9 ]*)' tpBoozeM = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       boozle %P2 %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> jinx( +)([a-zA-Z0-9 ]*)' tpJinx = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       jinx %P3 %;\
     /endif
/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> autojinx( +)([a-zA-Z0-9 ]*)$' tpAutoJinx = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       /jinx %P3 %;\
     /endif
/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> stopjinx$' tpStopJinx = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       /stopjinx %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> locate ([a-zA-Z0-9 ]*)' tpLocate = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       locate %P2 %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> kib\?$' tpLocKib = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       locate kren thief %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> faerie( *)([a-zA-Z0-9 ]*)' tpFaerie = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       faerie %P3 %;kill %P3 %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> follow$' tpFollow = \
     /if (PM & Bot) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       follow %P1 %;\
     /endif
/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> ic ([a-zA-Z0-9 ]*)' tpIC = \
     /if (PM & Bot) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       /uGag %{doGlance} %;\
       kill %P2 %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> pac(ify)?$' tpPacify = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       put sling in bag\10put marble in bag\10pacify\10get marble from bag\10get sling from bag\10keep sling\10keep marble %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> confess$' tpConfess = \
     /if (PM) \
       /if (Restrict & {P1} !/ TankListR) /return %;/endif %;\
       confess %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> res( +)([a-zA-Z0-9 ]*)' tpRes = \
     /if (PM) \
       /uGag %{doGlance} %;\
       resurrect %P3 %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> sd( *)([a-zA-Z0-9 ]*)' tpSD = \
     /if (PM) \
       /uGag %{doGlance} %;\
       /sd %P3 %;\
       /set SDreport=2 %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*<< ([A-Z][a-z]*) >> sds' tpSDS = \
     /if (PM) \
       /uGag %{doGlance} %;\
       spiritdisease stop %;\
       /set SDreport=0 %;\
     /endif

/def -iFp9999 -mregexp -t'^[> ]*.*appears ill\.\.\.$' tpSDstart = \
	/if (SDreport > 1) \
		/set SDreport 1 %;\
		say SD started %;\
	/endif

/def -iFp9999 -mregexp -t'[> ]*You grow tired, and your hold on .+ spirit collapses!$' tpSDOver = \
     /if (SDreport) \
       /set SDreport=0 %;\
       say SD over (Current SP: %SP/%MaxSP) %;\
     /endif 
/def -i -p9999 -mregexp -t'[> ]*Gruesly heads.*path.$' tpSDGrues = \
     /if (SDreport) \
       say SD cancelled %;\
       /tpSDS %;\
     /endif

/def -i -p9999 -mregexp -t'^[> ]*Water closes in over your head.' tpAWBme = \
  /if (PM) \
    /if (Flock) \
      flock waterbreath %;\
    /else \
      waterbreath %;\
    /endif %;\
  /endif

/def -i -p9999 -mregexp -t'^[> ]*Water closes in over ([a-zA-Z]*).$' tpAWB = \
  /if (PM) \
    /if ({P1} !/ TankListR) /return %;/endif %;\
    /if (Flock) \
      flock waterbreath %;\
    /else \
      waterbreath %P1 %;\
    /endif %;\
  /endif

;/def -i -p999 -t'*You fail to calm the room*' taPacify = \
;     /if (PM) \
;       do gasp,pacify %;\
;     /endif

; mortal/deadly/deadly
/def -i -p999 -mregexp -t'^[> ]*>>> ([A-Z][a-z]*) [a-zA-Z]* now ([a-zA-Z ]*). <<<' \
     tdTank = \
        /set doHeal=0 %;\
        /if (HealSelf & {P1} =/ "You") \
 		/set hWho= %;\
                /set doHeal=1 %;\
        /elseif (PM & {P1} =/ TankListR) \
             /set hWho=%P1 %;\
             /set doHeal=1 %;\
        /endif %;\
	/if (doHeal) \
             /set Jinx 0 %;/set Symbol 0 %;\
             /if ({P2} =~ "somewhat hurt") \
               /if (Flock) \
                 flock cure %;\
               /else \
                 cure %hWho %;\
               /endif %;\
             /elseif ({P2} =~ "badly hurt") \
               /if (Flock) \
                 flock cure %;\
               /else \
                 cure %hWho %;\
               /endif %;\
             /elseif ({P2} =~ "in very bad shape") \
               /if (Flock) \
                 flock cure %;\
               /else \
                 cure %hWho %;\
               /endif %;\
             /endif%;\
        /endif

/def -i -p999 -mregexp -t'^[> ]*([A-Z][a-z]*) charges into the room' \
     tdTankCharge = \
        /if (PM & {P1} =/ TankListR) \
          /if (Flock) \
            flock cure %;\
          /else \
            cure %P1 %;\
          /endif %;\
        /endif

/def -i -p999 -mregexp -t'^[> ]*.* makes the sign of a hex, and ([A-Z][a-z]*) staggers' \
     tdTankJinxed = \
        /if (PM & {P1} =/ TankListR) \
          /if (Flock) \
            flock cleanse %;\
          /else \
            cleanse %P1 %;\
          /endif %;\
        /endif

/def -i -p999 -mregexp -t'^[> ]*([A-Z][a-z]*) appears ill...$' tdTankSick = \
  /if (PM & {P1} =/ TankListR) \
    /if (Flock) \
      flock cleanse %;\
    /else \
      cleanse %P1 %;\
    /endif %;\
  /endif

/def -iFp999 -mregexp -t'^[> ]*([A-Z][a-z]*) died.$' tdTankDead = \
  /if (PM & {P1} =/ TankListR) \
    /repeat -2 1 resurrect %P1 %;\
  /endif

;/def -i -p999 -ah -t'*is about as drunk as * is likely to get*' tMaxBoozle = say Woo! Max Boozle!

/def -i makeTankList = \
        /set TankList=%* %;\
        /set TankListR {$(/makepipestr %{TankList})} %;\
	/ShowTanks
 
/def addtank = \
	/if /test {TankList} =~ "" %;/then \
		/makeTankList %1 %;\
	/else \
	        /makeTankList %1 %{TankList} %;\
	/endif

/def rmtank = \
        /makeTankList $(/remove %1 %{TankList})
 
;/def -i makepipestr = \
;	/if /test {#} == 1%;/then \
;		/echo -- %{1}%;\
;	/else \
;		/let tmpStr=%;\
;		/while /test {#}%;/do \
;			/let tmpStr=%{tmpStr}|%1%;\
;			/shift%;\
;		/done%;\
;		/echo -- %{tmpStr}%;\
;	/endif

/def -i ShowTanks = \
	/if /test {TankList} =~ ""%;/then \
		/echo -aB % Current Tanks: <none> %;\
	/else \
		/echo -aB % Current Tanks: %{TankList} %;\
	/endif
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Default Tank List
/makeTankList Serenity 
